Attribute VB_Name = "modMain"
' This program is an original work, Copyright 1999 by Joseph Gray. All rights reserved.
' -- modified to dump audio to .wav file - Marty Gulaian Feb 2002

' Things to do yet:

' ****** In tmrWait4Tape procedure, audio tape returns data first time around?
' In tmrWait4Tape procedure, what to do with a data tape?
' Comment code better.
' In TestUnitReady function - do I care what the not-ready conditions are?
' Make sure all functions return proper values. Case Else in all procedures.
' Error handling in all procedures to handle device resets and other situations.
' Reserve drive for exclusive use. Cleanup in QueryUnload.
' Detect data tape and update display.
' Rewrite Play functions to use a timer.
' Write lead-in function.
' Write lead-out function.
' Write audio functions.
' Construct subcode info and write functions.
' Parse subcode info on read.
' Update A-Time, P-Time, Pno and Sample Rate displays with subcode info.
' Blink display on/off function (timer).
' Search buttons and number pad.

' Previous/Next buttons.
' Cue button.
' Record button.
' Options menu functions.
' Wave file multiselect list box - retain selection order?
' Help and About.
' 44.1KHz read/write.
' How to handle 32KHz and other unexpected subcodes?
' Check audio card capabilities - 48KHz? Allow play if only 44.1KHz?
' Rewrite SCSI device enumeration code to handle more than one tape drive.
' If more than one tape drive, allow selection.
' If more than one tape drive, support tape duplication?

Option Explicit

Public Const NUM_BUFFERS As Long = 4            ' Data buffers for writing to sound card.
' Public Const NUM_FRAMES As Long = 30            ' Number of frames to read to fill a buffer.
Public Const NUM_FRAMES As Long = 10            ' Number of frames to read to fill a buffer.

Public hMem(1 To NUM_BUFFERS) As Long           ' Memory buffer handles. Returned by GlobalAlloc.
Public pMem(1 To NUM_BUFFERS) As Long           ' Memory buffer pointers. Returned by GlobalLock.
Public Hdr(1 To NUM_BUFFERS) As WaveHdrStruct   ' Wave headers.
Public hHdr(1 To NUM_BUFFERS) As Long           ' Handle to the wave format structure. Returned by GlobalAlloc.
Public pHdr(1 To NUM_BUFFERS) As Long           ' Pointer to the wave format structure. Returned by GlobalLock.
Public BufferSize As Long                       ' Size of the output buffers.
Public Playing As Boolean                       ' Is the Wave data currently playing?
Public hWaveOut As Long                         ' Wave output device handle.
Public Msg As String * 250                      ' Message buffer.
Public hWnd As Long                             ' Window handle.

' marty
Public Const SAMPLE_RATE_44 = 44
Public Const SAMPLE_RATE_48 = 48
Public Const SAMPLE_RATE_32 = 32 ' not supported
Public Const SAMPLE_RATE_UNK = 0 ' unknown sample rate

Public SampleRate As Long
Public LastProgramID As Byte ' made this global so can do next and prev

' Testing stuff to write a wave file.
'------------------------------------
Public FileNum As Integer, ErrLogFileNum As Integer
'Public FileLength As Long
Public WavFileName As String, BaseFileName As String
Public Const DefaultWavFilename As String = "DatDeck.wav"
Public Const DefaultErrLogFilename As String = "DatDeck.log"
'------------------------------------

' Array to hold info about each SCSI adapter/bus (maximum 8 adapters).
' Do I want to do it this way?
Public Adapter(7) As AdapterStruct

' Take these out later.
Public CurrentAdapter As Byte
Public CurrentDrive As Byte

' These hold the ID number of the SCSI card and the tape drive that support audio.
Public CardID As Byte
Public TapeID As Byte

' Flag to let me know that an audio-capable drive was found.
Public AudioDriveFound As Boolean

' Flag to indicate that a tape is in the drive.
Public AudioTapePresent As Boolean
Public DataTapePresent As Boolean

' Flag to let me know the STOP button was pressed during a Locate command.
'Public LocateAbort As Boolean

' Flag to let me know the "A-Time" button was clicked.
Public ATIME_CLICKED As Boolean

' Flag to let me know the "P-Time" button was clicked.
Public PTIME_CLICKED As Boolean

' Flag to let me know the "PNO" button was clicked.
Public PNO_CLICKED As Boolean

' Am I using this?
Public TimerFlag As Boolean

' ************************************************************************
'                   Peripheral Device Type Definitions
' ************************************************************************

Public Const DTYPE_DASD As Byte = &H0           ' Disk Device
Public Const DTYPE_SEQD As Byte = &H1           ' Tape Device
Public Const DTYPE_PRNT As Byte = &H2           ' Printer
Public Const DTYPE_PROC As Byte = &H3           ' Processor
Public Const DTYPE_WORM As Byte = &H4           ' Write-once read-multiple
Public Const DTYPE_CROM As Byte = &H5           ' CD-ROM device
Public Const DTYPE_SCAN As Byte = &H6           ' Scanner device
Public Const DTYPE_OPTI As Byte = &H7           ' Optical memory device
Public Const DTYPE_JUKE As Byte = &H8           ' Medium Changer device
Public Const DTYPE_COMM As Byte = &H9           ' Communications device
Public Const DTYPE_RESL As Byte = &HA           ' Reserved (low)
Public Const DTYPE_RESH As Byte = &H1E          ' Reserved (high)
Public Const DTYPE_UNKNOWN As Byte = &H1F       ' Unknown or no device type
Public Const DTYPE_HA As Byte = &HFF            ' Host Adapter (not an official type).

' ************************************************************************
'               Misc constants used by SCSI I/O commands
' ************************************************************************

Public Const SENSE_LEN As Byte = 14             ' Default sense buffer length.
Public Const SRB_DIR_IN As Byte = &H8           ' Transfer from SCSI target to host.
Public Const SRB_DIR_OUT As Byte = &H10         ' Transfer from host to SCSI target.
Public Const SRB_POSTING As Byte = &H1          ' Enable ASPI posting.
Public Const SRB_EVENT_NOTIFY As Byte = &H40    ' Enable ASPI event notification.
Public Const SRB_ENABLE_RESIDUAL_COUNT As Byte = &H4    ' Enable residual byte count reporting.

' ************************************************************************
'                   ASPI32 Subfunction Commands
' ************************************************************************
' According to the ASPI32 documentation (2 Jan 1997), SC_ABORT_SRB is not guaranteed
' to succeed and is not generally useful under Win32. Set SRB timeout on device instead.
' The SC_RESET_DEV command is also not guaranteed to work either (test this?).

Public Const SC_HA_INQUIRY As Byte = &H0        ' Host adapter inquiry.
Public Const SC_GET_DEV_TYPE As Byte = &H1      ' Get device type.
Public Const SC_EXEC_SCSI_CMD As Byte = &H2     ' Execute SCSI command.
Public Const SC_ABORT_SRB As Byte = &H3         ' Abort an SRB.
Public Const SC_RESET_DEV As Byte = &H4         ' SCSI bus device reset.
Public Const SC_GETSET_TIMEOUTS As Byte = &H8   ' Get/set SRB command timeout (default=30hrs).

' ************************************************************************
'                   ASPI32 Subfunction Return Codes
' ************************************************************************

Public Const SS_PENDING As Byte = &H0           ' SRB being processed
Public Const SS_COMP As Byte = &H1              ' SRB completed without error
Public Const SS_ABORTED As Byte = &H2           ' SRB aborted
Public Const SS_ABORT_FAIL As Byte = &H3        ' Unable to abort SRB
Public Const SS_ERR As Byte = &H4               ' SRB completed with error
Public Const SS_INVALID_CMD As Byte = &H80      ' Invalid ASPI command
Public Const SS_INVALID_HA As Byte = &H81       ' Invalid host adapter number
Public Const SS_NO_DEVICE As Byte = &H82        ' SCSI device not installed
Public Const SS_INVALID_SRB As Byte = &HE0      ' Invalid parameter set in SRB
Public Const SS_FAILED_INIT As Byte = &HE4      ' ASPI for windows failed init
Public Const SS_ASPI_IS_BUSY As Byte = &HE5     ' No resources available to execute cmd
Public Const SS_BUFFER_TO_BIG As Byte = &HE6    ' Buffer size to big to handle!

' ************************************************************************
'                   Host Adapter Status Values
' ************************************************************************

Public Const HASTAT_OK As Byte = &H0            ' Host adapter did not detect an error.
Public Const HASTAT_TIMEOUT As Byte = &H9       ' Timed out while SRB was waiting to be processed.
Public Const HASTAT_COMMAND_TIMEOUT = &HB       ' While processing the SRB, adapter timed out.
Public Const HASTAT_MESSAGE_REJECT As Byte = &HD    ' While processing SRB, the adapter received a MESSAGE REJECT.
Public Const HASTAT_BUS_RESET As Byte = &HE     ' A bus reset was detected.
Public Const HASTAT_PARITY_ERROR As Byte = &HF  ' A parity error was detected.
Public Const HASTAT_REQUEST_SENSE_FAILED As Byte = &H10 ' The adapter failed in issuing REQUEST SENSE.
Public Const HASTAT_SEL_TO As Byte = &H11       ' Selection Timeout.
Public Const HASTAT_DO_DU As Byte = &H12        ' Data overrun / data underrun.
Public Const HASTAT_BUS_FREE As Byte = &H13     ' Unexpected bus free.
Public Const HASTAT_PHASE_ERR As Byte = &H14    ' Target bus phase sequence failure.

' ************************************************************************
'                   Target Status Values
' ************************************************************************

Public Const STATUS_GOOD As Byte = &H0          ' Status Good.
Public Const STATUS_CHKCOND As Byte = &H2       ' Check Condition.
Public Const STATUS_CONDMET As Byte = &H4       ' Condition Met.
Public Const STATUS_BUSY As Byte = &H8          ' Busy.
Public Const STATUS_INTERM As Byte = &H10       ' Intermediate.
Public Const STATUS_INTCDMET As Byte = &H14     ' Intermediate-condition met.
Public Const STATUS_RESCONF As Byte = &H18      ' Reservation conflict.
Public Const STATUS_COMTERM As Byte = &H22      ' Command Terminated.
Public Const STATUS_QFULL As Byte = &H28        ' Queue full.

' ************************************************************************
'                   Sense Codes
' ************************************************************************

Public Const SENSE_CURRENT As Byte = &H70       ' Sense data is from current command.
Public Const SENSE_DEFFERED As Byte = &H71      ' Sense data is from a previous command.

' ************************************************************************
'                   Sense Key Values
' ************************************************************************

Public Const KEY_NOSENSE As Byte = &H0          ' No Sense.
Public Const KEY_RECERROR As Byte = &H1         ' Recovered Error.
Public Const KEY_NOTREADY As Byte = &H2         ' Not Ready.
Public Const KEY_MEDIUMERROR As Byte = &H3      ' Medium Error.
Public Const KEY_HARDERROR As Byte = &H4        ' Hardware Error.
Public Const KEY_ILLGLREQ As Byte = &H5         ' Illegal Request.
Public Const KEY_UNITATT As Byte = &H6          ' Unit Attention.
Public Const KEY_DATAPROT As Byte = &H7         ' Data Protection.
Public Const KEY_BLANKCHK As Byte = &H8         ' Blank Check.
Public Const KEY_VENDSPEC As Byte = &H9         ' Vendor Specific.
Public Const KEY_COPYABORT As Byte = &HA        ' Copy Aborted.
Public Const KEY_ABORTCMD As Byte = &HB         ' Aborted Command.
Public Const KEY_EQUAL As Byte = &HC            ' Equal (Search).
Public Const KEY_VOLOVRFLW As Byte = &HD        ' Volume Overflow.
Public Const KEY_MISCOMP As Byte = &HE          ' Miscompare (Search).
Public Const KEY_RSVD As Byte = &HF             ' Reserved.

' ************************************************************************
'                   SCSI Commands for all Device Types
' ************************************************************************

Public Const SCSI_TST_U_RDY As Byte = &H0       ' Test Unit Ready (Mandatory)
Public Const SCSI_REQ_SENSE As Byte = &H3       ' Request Sense (Mandatory)
Public Const SCSI_READ As Byte = &H8            ' Read (Mandatory)
Public Const SCSI_WRITE As Byte = &HA           ' Write (Mandatory)
Public Const SCSI_INQUIRY As Byte = &H12        ' Inquiry (Mandatory)
Public Const SCSI_MODE_SEL6 As Byte = &H15      ' Mode Select 6-byte (Device Specific)
Public Const SCSI_COPY As Byte = &H18           ' Copy (Optional)
Public Const SCSI_MODE_SEN6 As Byte = &H1A      ' Mode Sense 6-byte (Device Specific)
Public Const SCSI_SEND_DIAG As Byte = &H1D      ' Send Diagnostic (Optional)
Public Const SCSI_COMPARE As Byte = &H39        ' Compare (Optional)
Public Const SCSI_COP_VERIFY As Byte = &H3A     ' Copy and Verify (Optional)
Public Const SCSI_WRITE_BUFF As Byte = &H3B     ' Write Buffer (Optional)
Public Const SCSI_READ_BUFF As Byte = &H3C      ' Read Buffer (Optional)
Public Const SCSI_CHANGE_DEF As Byte = &H40     ' Change Definition (Optional)
Public Const SCSI_LOG_SELECT As Byte = &H4C     ' Log Select (Optional)
Public Const SCSI_LOG_SENSE As Byte = &H4D      ' Log Sense (Optional)
Public Const SCSI_MODE_SEL10 As Byte = &H55     ' Mode Select 10-byte (Device Specific)
Public Const SCSI_MODE_SEN10 As Byte = &H5A     ' Mode Sense 10-byte (Device Specific)

' ************************************************************************
'           SCSI Commands Unique to Sequential Access Devices
' ************************************************************************

Public Const SCSI_REWIND As Byte = &H1          ' Rewind (Mandatory)
Public Const SCSI_RD_BLK_LIM As Byte = &H5      ' Read Block Limits (Mandatory)
Public Const SCSI_READ_REV As Byte = &HF        ' Read Reverse (Optional)
Public Const SCSI_WRT_FILE As Byte = &H10       ' Write Filemarks (Mandatory)
Public Const SCSI_SPACE As Byte = &H11          ' Space (Mandatory)
Public Const SCSI_VERIFY_T As Byte = &H13       ' Verify (Optional)
Public Const SCSI_REC_BF_DAT As Byte = &H14     ' Recover Buffer Data (Optional)
Public Const SCSI_RESERVE As Byte = &H16        ' Reserve Unit (Mandatory)
Public Const SCSI_ERASE As Byte = &H19          ' Erase (Mandatory)
Public Const SCSI_LOAD_UN As Byte = &H1B        ' Load/Unload (Optional)
Public Const SCSI_PREVENT_ALLOW As Byte = &H1E  ' Prevent/Allow medium removal (Optional)
Public Const SCSI_LOCATE As Byte = &H2B         ' Locate (Optional)
Public Const SCSI_READ_POS As Byte = &H34       ' Read Position (Optional)

' ************************************************************************
'                       Various constants used by my procedures.
' ************************************************************************

Public Const LUN As Byte = 0                    ' No LUN support, so I set this to zero.

Public Const AUDIO_MODE = &H80                  ' Density code for audio mode.

' A catch-all constant that I created in case the ASPI32 functions returned
' undefined values. This should never happen (I hope).
Public Const UNDEFINED As Long = -99

Public Const TAPE_NONE As Long = &H0            ' No tape in drive.
Public Const TAPE_NEW As Long = &H1             ' New tape just inserted.
'Public Const EJECTED_MANUALLY As Long = &H3     ' User pushed eject button.

Public Const RESET As Long = &H4                ' Target device was reset.
Public Const BUSY As Long = &H5                 ' Target device reports busy.
Public Const READY As Long = &H6                ' Target device reports ready.

Public Const PREVENT As Byte = 1                ' Prevent medium removal.
Public Const ALLOW As Byte = 0                  ' Allow medium removal.

Public Const SUBCODESIZE As Long = 62           ' Number of audio subcode bytes in a frame.
Public Const AUDIOSIZE48 As Long = 5760         ' Number of audio data bytes in a frame at 48KHz.
' see comment at FRAMESIZE below
Public Const AUDIOSIZE44 As Long = 5292         ' Number of audio data bytes in a frame at 44.1Khz.
                                                ' note that one frame of cdr data is 588 samples = 2352
                                                ' bytes, not an even multiple! Be careful splitting files
                                                ' n.b. 44100 * 4 / 5292 = 33.33333 frames/second

' A complete 48k frame consists of the audio data, followed by the subcode data.
' frame size for 44k is the same, but the audio data is padded with zeros after 5292
Public Const FRAMESIZE As Long = AUDIOSIZE48 + SUBCODESIZE

' subcode stuff I care about
Public Const SUBCODE_SUBPACKCOUNT_BYTE As Long = 57  ' low order nibble
Public Const SUBCODE_PROGID_HIGH_BYTE As Long = 57   ' high order nibble
Public Const SUBCODE_PROGID_MID_BYTE As Long = 58    ' high order nibble
Public Const SUBCODE_PROGID_LOW_BYTE As Long = 58    ' low order nibble
Public Const SUBCODE_INTERPOLATEFLAGS_BYTE As Long = 59  ' 0 OK, 40H left channel bad, 20H right channel

Public Const SUBCODE_SAMPLERATE_BYTE As Long = 60  ' subcode byte 60 holds sample rate info
Public Const SUBCODE_SAMPLERATE_MASK As Byte = &HC ' in bits 2 and 3 (starting from 0)
Public Const SUBCODE_SAMPLERATE_48 As Byte = &H0   ' (00 00) 00 (00) means 48k
Public Const SUBCODE_SAMPLERATE_44 As Byte = &H4   ' (00 00) 01 (00) means 44.1k
Public Const SUBCODE_SAMPLERATE_32 As Byte = &H8   ' (00 00) 10 (00) means 32k
Public Const SUBCODE_SAMPLERATE_xx As Byte = &HC   ' (00 00) 11 (00) is reserved

' Used by the Locate SCSI command.
Public Const LOC_TYPE_PROG As Byte = 0          ' Locate by program number.
Public Const LOC_TYPE_ATIME As Byte = 1         ' Locate by absolute time.
Public Const LOC_TYPE_RTIME As Byte = 2         ' Locate by run time.
Public Const LOC_TYPE_PTIME As Byte = 3         ' Locate by program time.

' ************************************************************************
'                   Multimedia Constants and Flags
' ************************************************************************

Public Const WAVE_FORMAT_PCM As Integer = 1     ' Used in the WAVEFORMATEX structure.
Public Const MAXERRORLENGTH As Long = 128       ' Max length of string returned by wavOutGetErrorText.
Public Const GWL_WNDPROC As Long = -4           ' Used by the SetWindowLong function.

' Constant for the DeviceID parameter in waveOutOpen and waveInOpen.
Public Const MM_WAVE_MAPPER As Long = -1        ' Flag to set default wave device.

' Constants for Flags parameter in waveOutOpen.
Public Const CALLBACK_NULL As Long = 0          ' Don't use callback mode.
Public Const CALLBACK_FUNCTION As Long = &H30000    ' Callback to a function.
Public Const CALLBACK_WINDOW As Long = &H10000  ' Callback to a window.
Public Const WAVE_FORMAT_QUERY As Long = 1      ' See if device supports given format w/o opening device.
Public Const WAVE_ALLOWSYNC As Long = 2         ' A syncronous device can be opened. If not specified w/syncronous device, open will fail.
Public Const WAVE_MAPPED As Long = 4            ' If specified, the DeviceID specifies a wav-audio device to be mapped to by the wave mapper.
Public Const WAVE_FORMAT_DIRECT As Long = 8     ' ACM driver will not perform conversions on audio data.
Public Const WAVE_FORMAT_DIRECT_QUERY As Long = WAVE_FORMAT_QUERY Or WAVE_FORMAT_DIRECT

' Messages returned by waveOutOpen.
Public Const MM_WOM_DONE As Long = &H3BD        ' Finished playing current buffer of audio data.

' Constants for Flags field of WaveHdr.
Public Const WHDR_DONE As Long = 1              ' Set by driver when done playing.
Public Const WHDR_PREPARED As Long = 2          ' Set if this header has been prepared.
Public Const WHDR_BEGINLOOP As Long = 4         ' Loop start block.
Public Const WHDR_ENDLOOP As Long = 8           ' Loop end block.
Public Const WHDR_INQUEUE As Long = 16          ' Set by driver when data is queued for playback.

' ************************************************************************
'                   Multimedia Error Return Values
' ************************************************************************

' General error return values.
Public Const MMSYSERR_NOERROR As Long = 0       ' No error.
Public Const MMSYSERR_ERROR As Long = 1         ' Unspecified error.
Public Const MMSYSERR_BADDEVICEID As Long = 2   ' Device ID out of range.
Public Const MMSYSERR_NOTENABLED As Long = 3    ' Driver failed enable.
Public Const MMSYSERR_ALLOCATED As Long = 4     ' Device already allocated.
Public Const MMSYSERR_INVALHANDLE As Long = 5   ' Device handle is invalid.
Public Const MMSYSERR_NODRIVER As Long = 6      ' No device driver present.
Public Const MMSYSERR_NOMEM As Long = 7         ' Memory allocation error.
Public Const MMSYSERR_NOTSUPPORTED As Long = 8  ' Function isn't supported.
Public Const MMSYSERR_BADERRNUM As Long = 9     ' Error value out of range.
Public Const MMSYSERR_INVALFLAG As Long = 10    ' Invalid flag passed.
Public Const MMSYSERR_INVALPARAM As Long = 11   ' Invalid parameter passed.
Public Const MMSYSERR_HANDLEBUSY As Long = 12   ' Handle being used simultaneously on another thread (eg callback).
Public Const MMSYSERR_INVALIDALIAS As Long = 13 ' Specified alias not found.
Public Const MMSYSERR_BADDB As Long = 14        ' Bad registry database.
Public Const MMSYSERR_KEYNOTFOUND As Long = 15  ' Registry key not found.
Public Const MMSYSERR_READERROR As Long = 16    ' Registry read error.
Public Const MMSYSERR_WRITEERROR As Long = 17   ' Registry write error.
Public Const MMSYSERR_DELETEERROR As Long = 18  ' Registry delete error.
Public Const MMSYSERR_VALNOTFOUND As Long = 19  ' Registry value not found.
Public Const MMSYSERR_NODRIVERCB As Long = 20   ' Driver does not call DriverCallback.
Public Const MMSYSERR_LASTERROR As Long = 20    ' Last error in range.

' Wave function error return values.
Public Const WAVERR_BADFORMAT As Long = 32      ' Unsupported format.
Public Const WAVERR_STILLPLAYING As Long = 33   ' WAV still playing.
Public Const WAVERR_UNPREPARED As Long = 34     ' WAV buffer data not prepared.
Public Const WAVERR_SYNC As Long = 35           ' Device is syncronous but waveOutOpen called w/o WAVE_ALLOWSYNC flag.
'Public Const WAVERR_LASTERROR As Long = 35

' ************************************************************************
'               Constants used by the GlobalAlloc function.
' ************************************************************************

Public Const GMEM_FIXED As Long = &H0
Public Const GMEM_ZEROINIT As Long = &H40
Public Const GPTR As Long = (GMEM_FIXED Or GMEM_ZEROINIT)

' ************************************************************************
'                   User Defined Data Types (structures)
' ************************************************************************

' Multimedia Data Structures.
Public Type WaveHdrStruct                       ' Used by the waveIn/waveOut PrepareHeader/UnprepareHeader functions.
    Data As Long                                ' Address of the waveform buffer.
    BufferLength As Long                        ' Number of bytes in buffer.
    BytesRecorded As Long                       ' Used when recording. Number of bytes put in buffer.
    User As Long                                ' User data. What is this used for?
    Flags As Long                               ' See flags defined elsewhere.
    Loops As Long                               ' Times to play the buffer. Only used for output.
    Next As Long                                ' What is this?
    Reserved As Long                            ' Reserved.
End Type

Public Type WaveFormatExStruct                  ' Used by waveIn/waveOut Open functions.
    FormatTag As Integer                        ' Set to WAVE_FORMAT_PCM.
    Channels As Integer                         ' Number of channels. Set to 2.
    SamplesPerSec As Long                       ' Sample rate.
    AvgBytesPerSec As Long                      ' Set to 4 times sample rate for 16-bit stereo.
    BlockAlign As Integer                       ' Set to 4.
    BitsPerSample As Integer                    ' Set to 16.
    Size As Integer                             ' Not used. Set to zero.
End Type

' Used to hold a frame of audio and subcode data from a DAT tape at 48KHz.
' ****** Change the SubcodeData() array to a UDT to better define the subcodes. ******
Public Type DatFrame48Struct
    AudioData(AUDIOSIZE48 - 1) As Byte
    SubcodeData(SUBCODESIZE - 1) As Byte
End Type

Public Type DatFrame44Struct
    AudioData(AUDIOSIZE44 - 1) As Byte
    ZeroData(AUDIOSIZE48 - AUDIOSIZE44 - 1) As Byte
    SubcodeData(SUBCODESIZE - 1) As Byte
End Type

Public Type DecodedSubcodeStruct
    SampleRate As Long
    ErrorFlag As Boolean
    ProgramID As Long  ' should fit in byte but sometimes there's garbage input...
    ProgramIdString As String
    ProgramIDValid As Boolean
    ATimeHours As Byte
    ATimeMins As Byte
    ATimeSecs As Byte
    ATimeFrame As Byte
    PTimeHours As Byte
    PTimeMins As Byte
    PTimeSecs As Byte
    PTimeFrame As Byte
End Type

' A WAV file requires a 44-byte header before the audio data. Since a DAT tape uses
' only 16-bit samples and 2 channels at 48KHz or 44.1KHz, most of the values in  the
' header can be preset.
Public Type WavFileHeaderStruct
    HeaderName As String * 4                    ' Set = "RIFF".
    RiffChunkSize As Long                       ' Set to file length - 8.
    WavName As String * 4                       ' Set = "WAVE".
    FmtName As String * 4                       ' Set = "fmt ".
    FmtChunkSize As Long                        ' Set = 16.
    DataType As Integer                         ' Set = 1.
    NumChannels As Integer                      ' Set = 2.
    SampleRate As Long                          ' Set to either 48000 or 44100.
    AvBytesPerSec As Long                       ' Set to either 192000 or 176400.
    BlockAlign As Integer                       ' Set = 4.
    SampleSize As Integer                       ' Set = 16.
    DataName As String * 4                      ' Set = "data".
    DataLen As Long                             ' Set to file length - 44.
End Type

' Used to hold info about a host adapter/bus that was obtained from the Host Adapter
' Inquiry subfunction. The array Adapter() is used to hold info about each one found.
Public Type AdapterStruct
    SCSIId As Byte                      ' The SCSI ID of the host adapter itself (usually 7).
    TextName As String                  ' The Identifier name of the host adapter.
    MaxId As Byte                       ' Maximum SCSI ID supported (7 or 15).
    DeviceType(31) As Byte              ' Type of device (disk, tape, etc.) at each target ID.
End Type

' SRB for Host Adapter Inquiry subfunction.
Public Type SRBHaInquiryStruct          ' Variables marked as (I) are set before calling the function.
    SRBCmd As Byte                      ' (I) Command code = SC_HA_INQUIRY.
    SRBCmdStatus As Byte                ' Return status. Same as function return code.
    SRBHaId As Byte                     ' (I) Host adapter we're querying, starting with zero.
    SRBFlags As Byte                    ' (I) Reserved = 0.
    SRBHdrRsvd As Long                  ' (I) Reserved = 0.
    HaCount As Byte                     ' Number of host adapter busses installed. Set SRBHaId
                                        ' to zero to query this or use GetASPI32SupportInfo.
    HaSCSIId As Byte                    ' SCSI ID of the requested host adapter.
    HaManagerId As String * 16          ' Should return "ASPI for WIN32".
    HaIdentifier As String * 16         ' Name of host adapter.
    HaUnique(15) As Byte                ' Host adapter unique parameters. Encoded as:
                                        ' Byte 15-8     Reserved.
                                        ' Byte 7-4      Maximum transfer length (bytes?).
                                        ' Byte 3        Maximum targets/IDs supported.
                                        '               If not set, assumed to be 8.
                                        ' Byte 2        Bit 7-2     Reserved.
                                        '               Bit 1       If set, residual byte counting supported.
                                        '               Bit 0       Reserved.
                                        ' Byte 1-0      Buffer alignment mask.
                                        '               &h0000 = none (byte alignment).
                                        '               &h0001 = word alignment.
                                        '               &h0002 = double-word alignment.
                                        '               ...etc.
    HaRsvd As Integer                   ' (I) Reserved = 0.
End Type

' SRB for Get Device Type subfunction.
Public Type SRBGetDevTypeStruct         ' Variables marked as (I) are set before calling the function.
    SRBCmd As Byte                      ' (I) Command code = SC_GET_DEV_TYPE.
    SRBCmdStatus As Byte                ' Return status. Same as function return code.
    SRBHaId As Byte                     ' (I) Host adapter we're querying, starting with zero.
    SRBFlags As Byte                    ' (I) Reserved = 0.
    SRBHdrRsvd As Long                  ' (I) Reserved = 0.
    SRBTarget As Byte                   ' (I) SCSI ID of target device.
    SRBLun As Byte                      ' (I) Logical Unit Number (LUN) of target device.
    SRBDeviceType As Byte               ' Device type at this ID. Defined below.
    SRBRsvd As Byte                     ' (I) Reserved = 0.
End Type

' SRB for Execute SCSI I/O Command subfunction.
Public Type SRBExecIoCmdStruct
    SRBCmd As Byte                      ' (I) Command code = SC_EXEC_SCSI_CMD.
    SRBCmdStatus As Byte                ' Return status. Return codes are:
                                        ' SS_PENDING        SCSI request in progress.
                                        ' SS_COMP           Request completed w/o error.
                                        ' SS_ABORTED        Command was aborted.
                                        ' SS_ABORT_FAIL     Command abort failed.
                                        ' SS_ERR            Command completed w/error.
                                        ' SS_INVALID_SRB    SRB parameters are incorrect.
                                        ' SS_INVALID_PATH_ID    ID and LUN are invalid.
                                        ' SS_BUFFER_TO_BIG  ASPI manager can't handle this transfer size.
                                        ' SS_BUFFER_ALIGN   ASPI manager can't handle this buffer alignment.
                                        '                   You must force alignment specified by alignment mask.
                                        ' SS_SECURITY_VIOLATION Application doesn't have proper security privileges.
    SRBHaId As Byte                     ' (I) Host adapter we're querying, starting with zero.
    SRBFlags As Byte                    ' (I) SRB flags (OR'ed together) are:
                                        ' SRB_DIR_IN        Data transfer from device to host adapter.
                                        '                   Mutually exclusive with SRB_DIR_OUT.
                                        ' SRB_DIR_OUT       Data transfer from host adapter to device.
                                        '                   Mutually exclusive with SRB_DIR_IN.
                                        ' SRB_EVENT_NOTIFY  Enable ASPI command event notification.
                                        '                   Mutually exclusive with SRB_POSTING.
                                        ' SRB_POSTING       Enable ASPI command completion posting (callback).
                                        '                   Mutually exclusive with SRB_EVENT_NOTIFY.
                                        ' SRB_ENABLE_RESIDUALCOUNT  Enables reporting of residual byte count.
                                        '                   Only significant if HostAdapterInquiry reports
                                        '                   that host adapter supports it. When a data underrun
                                        '                   occurs, SRBBufLen is updated with the number of
                                        '                   remaining bytes to transfer.
    SRBHdrRsvd As Long                  ' (I) Reserved = 0.
    SRBTarget As Byte                   ' (I) SCSI ID of target device.
    SRBLun As Byte                      ' (I) Logical Unit Number (LUN) of target device.
    SRBRsvd1 As Integer                 ' (I) Reserved = 0.
    SRBBufLen As Long                   ' (I) Number of bytes to be transfered. If SCSI command
                                        ' doesn't transfer data (REWIND), must be set to zero.
                                        ' If residual byte count is selected, this returns with # of bytes.
    SRBBufPointer As Long               ' (I) Pointer to data buffer.
    SRBSenseLen As Byte                 ' (I) Number of bytes alocated at end of SRB for sense data.
    SRBCDBLen As Byte                   ' (I) Length in bytes of the Command Descriptor Block (CDB).
                                        ' This value is typically 6 or 10.
    SRBHaStat As Byte                   ' Returns with status of host adapter:
                                        ' HASTAT_OK             No errors.
                                        ' HASTAT_TIMEOUT        Transaction timed out.
                                        ' HASTAT_COMMAND_TIMEOUT    SRB expired waiting to be processed.
                                        ' HASTAT_SEL_TO         Selection of target timed out.
                                        ' HASTAT_MESSAGE_REJECT Processing SRB, adapter received a MESSAGE REJECT.
                                        ' HASTAT_BUS_RESET      A bus reset was detected.
                                        ' HASTAT_PARITY_ERROR   A parity error was detected.
                                        ' HASTAT_REQUEST_SENSE_FAILED   Adapter failed issuing a REQEST SENSE
                                        '                       after a check condition was reported by target device.
                                        ' HASTAT_DO_DU          Data overrun/underrun.
                                        ' HASTAT_BUS_FREE       Unexpected Bus Free.
                                        ' HASTAT_PHASE_ERR      Target bus phase sequence failure.
    SRBTargetStat As Byte               ' Status returned by the target device:
                                        ' STATUS_GOOD       No target status.
                                        ' STATUS_CHKCOND    Check status (sense data is in SenseArea).
                                        ' STATUS_BUSY       Target/LUN is busy.
                                        ' STATUS_RESCONF    Reservation conflict.
    SRBPostProc As Long                 ' (I) If posting enabled, this contains a pointer to a function.
                                        ' ASPI32 calls this function upon completion of an ASPI request.
                                        ' If event notification enabled, this contains a handle to an event.
                                        ' ASPI32 signals this event upon completion of an ASPI request.
    SRBRsvd2 As Long                    ' (I) Pointer. Reserved = 0.
    SRBRsvd3(15) As Byte                ' (I) Reserved. Fill with 16 zeros?
    CDBByte(15) As Byte                 ' (I) Contains the CDB as defined by the target's SCSI command set.
                                        ' The length is specified in SRB_CDBLen.
    SenseArea(SENSE_LEN + 2) As Byte    ' Contains the sense data when a check condition occurs.
                                        ' Maximum length is specified by (SRB_SenseLen + 2).
                                        ' Target can return fewer sense bytes than requested.
End Type

' SRB for Abort I/O Command subfunction.
Public Type SRBAbortIoCmdStruct         ' Variables marked as (I) are set before calling the function.
    SRBCmd As Byte                      ' (I) Command code = SC_ABORT_SRB.
    SRBCmdStatus As Byte                ' Return status. Same as function return code.
    SRBHaId As Byte                     ' (I) Host adapter we're querying, starting with zero.
    SRBFlags As Byte                    ' (I) Reserved = 0.
    SRBHdrRsvd As Long                  ' (I) Reserved = 0.
    SRBtoAbort As Long                  ' (I) Pointer to the SRB to be aborted.
End Type

' SRB for Reset Device subfunction.
Public Type SRBResetDeviceStruct
    SRBCmd As Byte                      ' (I) Command code = SC_RESET_DEV.
    SRBCmdStatus As Byte                ' Return status. Return codes are:
                                        ' SS_PENDING        SCSI request in progress.
                                        ' SS_COMP           Request completed w/o error.
                                        ' SS_ABORTED        Command was aborted.
                                        ' SS_ABORT_FAIL     Command abort failed.
                                        ' SS_ERR            Command completed w/error.
                                        ' SS_INVALID_SRB    SRB parameters are incorrect.
                                        ' SS_INVALID_PATH_ID    ID and LUN are invalid.
    SRBHaId As Byte                     ' (I) Host adapter we're querying, starting with zero.
    SRBFlags As Byte                    ' (I) Reserved = 0.
    SRBHdrRsvd As Long                  ' (I) Reserved = 0.
    SRBTarget As Byte                   ' (I) SCSI ID of target device.
    SRBLun As Byte                      ' (I) Logical Unit Number (LUN) of target device.
    SRBRsvd1(11) As Byte                ' (I) Reserved. Fill with zeros?
    SRBHaStat As Byte                   ' Returns with status of host adapter:
                                        ' HASTAT_OK             No errors.
                                        ' HASTAT_TIMEOUT        Transaction timed out.
                                        ' HASTAT_COMMAND_TIMEOUT    SRB expired waiting to be processed.
                                        ' HASTAT_SEL_TO         Selection of target timed out.
                                        ' HASTAT_MESSAGE_REJECT Processing SRB, adapter received a MESSAGE REJECT.
                                        ' HASTAT_BUS_RESET      A bus reset was detected.
                                        ' HASTAT_PARITY_ERROR   A parity error was detected.
                                        ' HASTAT_REQUEST_SENSE_FAILED   Adapter failed issuing a REQEST SENSE
                                        '                       after a check condition was reported by target device.
                                        ' HASTAT_DO_DU          Data overrun/underrun.
                                        ' HASTAT_BUS_FREE       Unexpected Bus Free.
                                        ' HASTAT_PHASE_ERR      Target bus phase sequence failure.
    SRBTargetStat As Byte               ' Status returned by the target device:
                                        ' STATUS_GOOD       No target status.
                                        ' STATUS_CHKCOND    Check status (sense data is in SenseArea).
                                        ' STATUS_BUSY       Target/LUN is busy.
                                        ' STATUS_RESCONF    Reservation conflict.
    SRBPostProc As Long                 ' (I) If posting enabled, this contains a pointer to a function.
                                        ' ASPI32 calls this function upon completion of an ASPI request.
                                        ' If event notification enabled, this contains a handle to an event.
                                        ' ASPI32 signals this event upon completion of an ASPI request.
    SRBRsvd2 As Long                    ' (I) Pointer. Reserved = 0.
    SRBRsvd3(31) As Byte                ' (I) Reserved. Fill with zeros?
End Type

' SRB for Rescan Bus subfunction.
'Public Type SRBRescanBusStruct           ' Variables marked as (I) are set before calling the function.
'    SRBCmd As Byte                      ' (I) Command code = SC_RESCAN_SCSI_BUS.
'    SRBCmdStatus As Byte                ' Return status. Same as function return code.
'    SRBHaId As Byte                     ' (I) Host adapter we're querying, starting with zero.
'    SRBFlags As Byte                    ' (I) Reserved = 0.
'    SRBHdrRsvd As Long                  ' (I) Reserved = 0.
'End Type

' SRB for Get Set Timeouts subfunction.
Public Type SRBTimeoutsStruct           ' Variables marked as (I) are set before calling the function.
    SRBCmd As Byte                      ' (I) Command code = SC_GET_DEV_TYPE.
    SRBCmdStatus As Byte                ' Return status. Same as function return code.
    SRBHaId As Byte                     ' (I) Host adapter we're querying, starting with zero.
    SRBFlags As Byte                    ' (I) Reserved = 0.
    SRBHdrRsvd As Long                  ' (I) Reserved = 0.
    SRBTarget As Byte                   ' (I) SCSI ID of target device.
    SRBLun As Byte                      ' (I) Logical Unit Number (LUN) of target device.
    SRBTimeout As Byte                  ' Timeout in 1/2 second increments (30hr. max).
End Type

' ************************************************************************
'                       Function Declarations
' ************************************************************************

Public Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (ByVal Dest As Long, ByVal Source As Long, ByVal Length As Long)

' Used to setup the callback (from waveOutWrite) and make it work.
'Public Declare Function PostWavMessage Lib "user32" Alias "PostMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByRef Hdr As WaveHdrStruct) As Long
'Public Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hWnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByRef lParam As WaveHdrStruct) As Long
'Public Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long

' General purpose API routines.
Public Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)

' The WNASPI32.DLL that provides ASPI support for both Win95 and WinNT is not
' compatible with being called from VB (ask a C programmer why), so a wrapper
' DLL is needed to interface the two. This wrapper is ASPIWRAP.DLL. The two
' funtions in the original DLL are given names with a "J" appended in the wrapper.

Declare Function GetASPI32SupportInfoJ Lib "aspiwrap" () As Long
' Initialize ASPI manager and return number of logical SCSI busses.
' Note that IDE/ATAPI interfaces are counted in this by ASPI32.

' After ASPI manager is initialized, the SendASPI32Command function does all the work.
' Each subfunction (such as HostAdapterInquiry) requires a SCSI Request Block (SRB).
' Since the SRB can be of variable length, each subfunction needs its own function declaration.

Declare Function HostAdapterInquiry Lib "aspiwrap" Alias "SendASPI32CommandJ" (SRB As SRBHaInquiryStruct) As Long
' Used to get information about a host adapter (name, ID, unique parameters, etc.),
' as well as the number of host adapters installed.
' Function return codes are:
' SS_COMP           Request completed without error.
' SS_INVALID_HA     Invalid host adapter number.

Declare Function GetDeviceType Lib "aspiwrap" Alias "SendASPI32CommandJ" (SRB As SRBGetDevTypeStruct) As Long
' Used to identify the devices attached to a SCSI bus.
' Function return codes are:
' SS_COMP           Request completed without error.
' SS_INVALID_HA     Invalid host adapter number.
' SS_NO_DEVICE      SCSI device not installed.

Declare Function ExecuteIoCommand Lib "aspiwrap" Alias "SendASPI32CommandJ" (SRB As SRBExecIoCmdStruct) As Long
' Once an ASPI client is initialized, virtually all I/O is done with this command.
' Function return codes are:
' SS_PENDING        SCSI request is in progress.

Declare Function AbortIoCommand Lib "aspiwrap" Alias "SendASPI32CommandJ" (SRB As SRBAbortIoCmdStruct) As Long
' Request that a pending SRB be aborted. Use when you wish to timeout on an I/O request.
' Success of the abort command is never assured.
' Function return codes are:
' SS_COMP           Request completed without error.
' SS_INVALID_HA     Invalid host adapter number.
' SS_INVALID_SRB    Parameters in the SRB are incorrect.

Declare Function ResetDevice Lib "aspiwrap" Alias "SendASPI32CommandJ" (SRB As SRBResetDeviceStruct) As Long
' Send a SCSI Bus Device Reset to the specified target device.
' Function return codes are:
' SS_PENDING        SCSI request is in progress.

'Declare Function RescanBus Lib "aspiwrap" Alias "SendASPI32CommandJ" (SRB As SRBRescanBusStruct) As Long
' Does this work under Win95? Rescan SCSI bus and update System Device Map.
' This function will only detect newly added devices, not removed/exchanged devices.
' Function return codes are:
' SS_COMP           Request completed without error.
' SS_INVALID_HA     Invalid host adapter number.
' SS_INVALID_SRB    Parameters in the SRB are incorrect.

Declare Function GetSetTimeouts Lib "aspiwrap" Alias "SendASPI32CommandJ" (SRB As SRBTimeoutsStruct) As Long
' Gets or sets the timeout (in 1/2 second increments) value on an SRB command.
' This is settable on individual targets or all targets.
' Function return codes are:
' SS_COMP           Request completed without error.
' SS_INVALID_HA     Invalid host adapter number.
' SS_INVALID_SRB    Parameters in the SRB are incorrect.
' SS_NO_DEVICE      No target device at this ID.



Public Function AbortSCSICommand(AdapterNum As Byte, TargetId As Byte, SRBtoAbort As SRBExecIoCmdStruct) As Boolean

' Abort Command is not supported by WinASPI. Function returns ok, but does nothing.
        
Dim AspiStatus As Long
Dim SRB As SRBAbortIoCmdStruct
Dim i As Long

'LocateAbort = False

SRB.SRBCmd = SC_ABORT_SRB                       ' Abort command.
SRB.SRBHaId = AdapterNum
SRB.SRBFlags = 0
SRB.SRBHdrRsvd = 0
SRB.SRBtoAbort = VarPtr(SRB)                    ' Pointer to the Locate SRB currently executing.

AspiStatus = AbortIoCommand(SRB)

Do While SRB.SRBCmdStatus = SS_PENDING          ' Wait until command has completed.

  DoEvents                                    ' Yield to other processes while waiting.
  Sleep 50

Loop

Select Case SRB.SRBCmdStatus                    ' Check return code.

    Case SS_COMP                                ' Command completed ok.
        MsgBox ("Abort Completed.")             ' What to do here?
    Case SS_INVALID_HA
        MsgBox ("Invalid HA in Abort Locate.")
    Case SS_INVALID_SRB
       MsgBox ("Invalid SRB in Abort Locate.")

    Case Else                                   ' Shouldn't happen.

End Select

End Function


Public Function BcdToLong(Num As Byte) As Long

Dim HiDigit As Long
Dim LoDigit As Long

HiDigit = Num \ 16

LoDigit = Num Mod 16

HiDigit = HiDigit * 10

BcdToLong = HiDigit + LoDigit

End Function

Public Function GetCurrentMode(AdapterNum As Byte, TargetId As Byte) As Byte

' Determine current density code by calling Mode Sense function.

Dim ModeData(11) As Byte
Dim Status As Boolean

Status = ModeSense(AdapterNum, TargetId, ModeData())

GetCurrentMode = ModeData(4)

End Function

Public Function SetDefaultMode(AdapterNum As Byte, TargetId As Byte) As Boolean

Dim ModeData(11) As Byte
Dim Status As Boolean

ModeData(0) = 0                                 ' Reserved.
ModeData(1) = 0                                 ' Reserved.
ModeData(2) = &H10                              ' Set buffered mode (default).
ModeData(3) = 8                                 ' Block Descriptor Length (default).
ModeData(4) = 0                                 ' Use default density mode.
ModeData(5) = 0                                 ' MSB.
ModeData(6) = 0                                 ' Number of blocks on tape (000H = default).
ModeData(7) = 0                                 ' LSB.
ModeData(8) = 0                                 ' Reserved.
ModeData(9) = 0                                 ' MSB.
ModeData(10) = 2                                ' Set 512 byte block size (020H = default).
ModeData(11) = 0                                ' LSB.

Status = ModeSelect(AdapterNum, TargetId, ModeData())

SetDefaultMode = Status

End Function

Public Function EjectTape(AdapterNum As Byte, TargetId As Byte) As Boolean
' Eject the tape in the drive specified by TargetID on the host adapter specified by
' AdapterNum. Uses the Execute I/O Command subfunction of the SendASPI32Command function.
' Returns TAPE_NONE, TAPE_NEW, EJECTED_OK.

Dim AspiStatus As Long
Dim SRB As SRBExecIoCmdStruct
Dim i As Long

' Initialize required variables before calling function.
SRB.SRBCmd = SC_EXEC_SCSI_CMD
SRB.SRBHaId = AdapterNum
SRB.SRBFlags = 0                                ' Set polling mode.
SRB.SRBHdrRsvd = 0
SRB.SRBTarget = TargetId
SRB.SRBLun = LUN
SRB.SRBRsvd1 = 0
SRB.SRBBufLen = 0                               ' No data transfered with this command,
SRB.SRBBufPointer = vbNull                      ' so no data buffer is needed.
SRB.SRBSenseLen = SENSE_LEN
SRB.SRBCDBLen = 6
SRB.SRBPostProc = vbNull                        ' Use polling to determine command completion.
SRB.SRBRsvd2 = 0
For i = 0 To 15                                 ' Fill this reserved field with all zeros.
    SRB.SRBRsvd3(i) = 0
Next i
SRB.CDBByte(0) = SCSI_LOAD_UN                   ' Load/unload command.
SRB.CDBByte(1) = 0
SRB.CDBByte(2) = 0
SRB.CDBByte(3) = 0
SRB.CDBByte(4) = 0                              ' Bit 0 of this byte reset means unload.
SRB.CDBByte(5) = 0

AspiStatus = ExecuteIoCommand(SRB)

Do While SRB.SRBCmdStatus = SS_PENDING          ' Wait until command has completed.
  DoEvents                                    ' Yield to other processes while waiting.
  Sleep 50
Loop

Select Case SRB.SRBCmdStatus                    ' Function/command return code is here.

    Case SS_COMP                                ' Command completed ok.
        EjectTape = True
        
    Case Else
        EjectTape = False                       ' It either ejected or it didn't.
        
End Select

End Function

Public Function HaInquiry(AdapterNum As Byte) As Long
' Get the parameters for the current host adapter. Uses the Host Adapter Inquiry
' subfunction of the SendASPI32Command function.

Dim AspiStatus As Long
Dim SRB As SRBHaInquiryStruct

' Initialize required variables before calling function.
SRB.SRBCmd = SC_HA_INQUIRY
SRB.SRBHaId = AdapterNum
SRB.SRBFlags = 0
SRB.SRBHdrRsvd = 0
SRB.HaRsvd = 0

AspiStatus = HostAdapterInquiry(SRB)            ' Call the function.

 Select Case AspiStatus
 
    Case SS_COMP                                ' Function completed ok.
        Adapter(AdapterNum).SCSIId = SRB.HaSCSIId   ' Assign values to public variables.
        Adapter(AdapterNum).TextName = Left(SRB.HaIdentifier, InStr(SRB.HaIdentifier, Chr$(0)) - 1)
        Adapter(AdapterNum).MaxId = SRB.HaUnique(3) - 1
        HaInquiry = SS_COMP
        
    Case SS_INVALID_HA                          ' Not a valid host adapter number.
        HaInquiry = SS_INVALID_HA
        
    Case Else                                   'This should never happen.
        HaInquiry = UNDEFINED
        
End Select

End Function

Public Function Locate(AdapterNum As Byte, TargetId As Byte, LocType As Byte, Num1 As Byte, Num2 As Byte, Num3 As Byte) As Boolean

Dim AspiStatus As Long
Dim AbortStatus As Long
Dim SRB As SRBExecIoCmdStruct
Dim i As Long

' Initialize required variables before calling function.
SRB.SRBCmd = SC_EXEC_SCSI_CMD
SRB.SRBHaId = AdapterNum
SRB.SRBFlags = 0                                ' No data transfered.
SRB.SRBHdrRsvd = 0
SRB.SRBTarget = TargetId
SRB.SRBLun = LUN
SRB.SRBRsvd1 = 0
SRB.SRBBufLen = 0                               ' No buffer needed.
SRB.SRBBufPointer = vbNull
SRB.SRBSenseLen = SENSE_LEN
SRB.SRBCDBLen = 10
SRB.SRBPostProc = vbNull                        ' With polling, no function or handle to point to.
SRB.SRBRsvd2 = 0
For i = 0 To 15                                 ' Fill this reserved field with all zeros.
    SRB.SRBRsvd3(i) = 0
Next i
SRB.CDBByte(0) = SCSI_LOCATE                    ' Locate command.
SRB.CDBByte(1) = 4                              ' Immediate mode is bit zero (make the 4 a 5).
SRB.CDBByte(2) = 0
SRB.CDBByte(3) = LocType * 32                   ' Shift Locate Type into upper 3-bits.

Select Case LocType
    Case LOC_TYPE_PROG                          ' Locate by program number.
        SRB.CDBByte(4) = Num1                   ' Put program numbers in these bytes.
        SRB.CDBByte(5) = Num2
        SRB.CDBByte(6) = Num3
        
    Case LOC_TYPE_ATIME, LOC_TYPE_RTIME, LOC_TYPE_PTIME     ' Locate by absolute/run/program time.
        SRB.CDBByte(4) = LongToBcd(CLng(Num1))
        SRB.CDBByte(5) = LongToBcd(CLng(Num2))
        SRB.CDBByte(6) = LongToBcd(CLng(Num3))
        
        
    Case Else
        MsgBox ("Wrong Locate Type specified.")
        Exit Function
    
End Select

SRB.CDBByte(7) = 0                              ' Frame number.
SRB.CDBByte(8) = 0
SRB.CDBByte(9) = 0
        


AspiStatus = ExecuteIoCommand(SRB)

Do While SRB.SRBCmdStatus = SS_PENDING          ' Wait until command has completed.
    
  DoEvents                                    ' Yield to other processes while waiting.
  Sleep 50


'    LocateAbort = False

'    If LocateAbort = True Then                  ' Flag set, so abort Locate in progress.
'
'        AbortStatus = AbortSCSICommand(AdapterNum, TargetId, SRB)
'
'    End If

Loop

Select Case SRB.SRBCmdStatus                    ' Function/command return code is here.

    Case SS_COMP                                ' Command completed ok.
        
    Case SS_ERR                                 ' Command completed w/error.

    Case SS_ABORTED                             ' Command successfully aborted.
        MsgBox ("Locate aborted ok.")
        
    Case Else
    
End Select


End Function

Public Function LongToBcd(Num As Long) As Byte

Dim HiDigit As Byte
Dim LoDigit As Byte

If Num > 99 Then
    MsgBox ("Number too long to convert to BCD. Must be 99 or less.")
    Exit Function
End If

HiDigit = Num \ 10

LoDigit = Num Mod 10

HiDigit = HiDigit * 16

LongToBcd = HiDigit + LoDigit

End Function

Public Sub Main()

Dim NumAdapters As Long
Dim HaStatus As Long
Dim AspiStatus As Long
Dim Status As Long
Dim SRB As SRBGetDevTypeStruct
Dim CurrentAdapter As Byte
Dim SavedDensity As Byte
Dim i As Long
Dim j As Long
Dim k As Long

' Initialize the ASPI32 Manager before doing anything else.
NumAdapters = ASPIInitialize()

If NumAdapters = 0 Then                         ' Failed to initialize for some reason.
    
    MsgBox ("Could not initialize ASPI Manager (WNASPI32.DLL). Program will terminate.")
    End                                         ' Exit program.

Else                                            ' Initialized ok.

    For i = 0 To NumAdapters - 1                ' Query each host adapter found.
        
        If i > 7 Then                           ' More than 8 host adapters.
            Exit For                            ' Throw them away.
        End If
        
        CurrentAdapter = i

        HaStatus = HaInquiry(CurrentAdapter)    ' Get Host Adapter parameters.
        
        Select Case HaStatus
            
            Case SS_COMP                        ' Got parameters ok.
                
                ' Initialize required variables before function call.
                SRB.SRBCmd = SC_GET_DEV_TYPE
                SRB.SRBHaId = CurrentAdapter
                SRB.SRBFlags = 0
                SRB.SRBHdrRsvd = 0
                SRB.SRBLun = LUN
        
                ' Skip IDE/ATAPI busses.
                If (InStr(UCase(Adapter(CurrentAdapter).TextName), "ATAPI") = 0) Then
                                
                    ' Enumerate each SCSI ID on the bus to see what device (if any) is there.
                    For j = 0 To Adapter(CurrentAdapter).MaxId
                
                        If j <> Adapter(CurrentAdapter).SCSIId Then ' Skip ID of the adapter card itself.
                            
                            SRB.SRBTarget = j               ' Target ID to query.
                            
                            AspiStatus = GetDeviceType(SRB) ' Subfunction of SendASPI32Command function.
                        
                            Select Case AspiStatus
                            
                                Case SS_COMP                ' Completed ok. Save device type.
                                
                                    Adapter(CurrentAdapter).DeviceType(j) = SRB.SRBDeviceType
                                    
                                    If SRB.SRBDeviceType = DTYPE_SEQD Then  ' Tape drive.
                                    
                                        For k = 1 To 4  ' Do enough times to clear reset or not ready status.
                                        
                                            Status = TestUnitReady(CurrentAdapter, SRB.SRBTarget)
                                            
                                            If (Status = TAPE_NONE) Or (Status = READY) Then
                                                
                                                ' Get current density code.
                                                SavedDensity = GetCurrentMode(CurrentAdapter, SRB.SRBTarget)
                                                
                                                ' Try to set audio mode. If successful, save bus # and ID.
                                                ' This should pick up the last audio drive if more than one exists.
                                                If SetAudioMode(CurrentAdapter, SRB.SRBTarget) = True Then
                                                
                                                    ' Restore previous mode.
                                                    Status = SetNewMode(CurrentAdapter, SRB.SRBTarget, SavedDensity)
                                                    
                                                    ' Save these in public variables for later use.
                                                    CardID = CurrentAdapter
                                                    TapeID = SRB.SRBTarget
                                                    
                                                    AudioDriveFound = True
                                                    
                                                    k = 4   ' Force exit from loop.
                                                    
                                                End If
                                                
                                            End If
                                            
                                        Next k
                                        
                                    End If
                        
                                Case SS_NO_DEVICE
                                
                                    Adapter(CurrentAdapter).DeviceType(j) = DTYPE_UNKNOWN
                                
                                Case SS_INVALID_HA          ' Just in case.
                                    
                                    MsgBox ("Invalid Host Adapter number in sub Main.")
                                    End
                                
                                Case Else
                                
                                    MsgBox ("Undefined AspiStatus in sub Main.")
                                    End
                                    
                            End Select
                            
                        Else                        ' Host Adapter at this Target ID.
                                                    ' Store it here too, just for consistency.
                            Adapter(CurrentAdapter).DeviceType(j) = DTYPE_HA
                            
                        End If
                        
                    Next j
                    
                End If
            Case SS_INVALID_HA                  ' Just in case.
                
                MsgBox ("Invalid Host Adapter number in sub Main.")
                End                             ' Exit program.
                
            Case UNDEFINED                      ' This should never happen.
                
                MsgBox ("Undefined value returned from HostAdapterInquiry function in sub Main.")
                End                             ' Exit program.
                
        End Select

    Next i
    
    If AudioDriveFound = False Then
    
        MsgBox ("An audio-capable tape drive was not found. Program will exit.")
        
        End
        
    End If
    
    frmDeck.Height = 3810                       ' Set form runtime dimensions.
    frmDeck.Width = 6260
    
    Load frmDeck                                ' Preload form for faster display.
    
    For i = 0 To 4
    
        ' Set picture box scalemode to pixels.
        frmDeck.picAtime(i).ScaleMode = 3
        frmDeck.picPtime(i).ScaleMode = 3
        
    Next i
    
    Call frmDeck.DisableAllButtons
    
'    frmMain.Show
    frmDeck.Show
    
    frmDeck.picAtime(0).SetFocus                ' Move focus to somewhere it won't show.
    
    ' Cycle display (8's, data, dashes) - just for looks.
'    frmDeck.SetDisplayTo8s
'    For i = 0 To 30000                          ' Can't use Sleep - prevents form loading.
'        DoEvents
'    Next i
'    Call frmDeck.SetDisplayToData
'    Call Sleep(1000)
    Call frmDeck.SetDisplayToBlank

    ' marty - made timer into a run-once func - see comments at
    ' checkTapeStatus()
    Call frmDeck.checkTapeStatus
    
    ' Enable timer that waits for a tape to be inserted.
'    frmDeck.tmrWait4Tape.Interval = 1000
'    frmDeck.tmrWait4Tape.Enabled = True

'    ' Wait for a tape - forever.
'    Do Until AudioTapePresent = True
'        DoEvents
'    Loop
End If

End Sub
Public Function LoWord(DWord As Long) As Long

LoWord = DWord And &HFFFF

End Function
Public Function HiWord(DWord As Long) As Long

HiWord = (DWord And &HFFFF0000) \ &H10000

End Function
Public Function HiByte(Word As Long) As Integer

HiByte = (Word And &HFF00) \ &H100

End Function
Public Function LoByte(Word As Long) As Integer

LoByte = Word And &HFF

End Function
Public Function ASPIInitialize() As Long
' The ASPI32 Manager has to be initialized before any other ASPI32 functions
' can be used. The function GetASPI32SupportInfo in WNASPI32.DLL is called
' to initialize the DLL and determine how many logical SCSI busses are present.
' Win95 and WinNT count IDE/ATAPI interfaces as SCSI busses under ASPI32.
' We'll have to handle these elsewhere.

Dim AspiStatus As Long
Dim NumAdapters As Byte

AspiStatus = GetASPI32SupportInfoJ()            ' Call the function.

' A double-word is returned. The high-word is reserved and not used. Only the
' two bytes of the low-word are used. The high-byte of this word returns either
' SS_COMP or SS_FAILED_INIT. If SS_COMP, then the low-byte of the word returns
' the number of logical host adapters (SCSI busses) present.

Select Case (HiByte(LoWord(AspiStatus)))

    Case SS_COMP                                ' Initialized ok. Report # of busses.
        NumAdapters = LoByte(LoWord(AspiStatus))
        ASPIInitialize = NumAdapters

    Case SS_FAILED_INIT
        ASPIInitialize = 0                      ' Failed initialization. Report no SCSI bus.

    Case Else                                   ' Shouldn't happen, but just in case.
        MsgBox ("ASPIInitialize:ASPIStatus=" + Hex(AspiStatus) + "H")
        End

End Select

End Function

Public Function ModeSelect(AdapterNum As Byte, TargetId As Byte, ModeSelectData() As Byte) As Boolean

Dim AspiStatus As Long
Dim SRB As SRBExecIoCmdStruct
Dim i As Long

' Initialize required variables before calling function.
SRB.SRBCmd = SC_EXEC_SCSI_CMD
SRB.SRBHaId = AdapterNum
SRB.SRBFlags = SRB_DIR_OUT                      ' Data going to target.
SRB.SRBHdrRsvd = 0
SRB.SRBTarget = TargetId
SRB.SRBLun = LUN
SRB.SRBRsvd1 = 0
SRB.SRBBufLen = 12                              ' 12-bytes of Select data will be sent.
SRB.SRBBufPointer = VarPtr(ModeSelectData(0))   ' Point to array to hold select data.
SRB.SRBSenseLen = SENSE_LEN
SRB.SRBCDBLen = 6
SRB.SRBPostProc = vbNull                        ' With polling, no function or handle to point to.
SRB.SRBRsvd2 = 0
For i = 0 To 15                                 ' Fill this reserved field with all zeros.
    SRB.SRBRsvd3(i) = 0
Next i
SRB.CDBByte(0) = SCSI_MODE_SEL6                 ' 6-byte Mode Select command.
SRB.CDBByte(1) = 0
SRB.CDBByte(2) = 0
SRB.CDBByte(3) = 0
SRB.CDBByte(4) = 12                             ' Allocation Length. Send Parameter List
                                                ' Header (4-bytes) and Block Descriptor (8-bytes).
SRB.CDBByte(5) = 0

AspiStatus = ExecuteIoCommand(SRB)

Do While SRB.SRBCmdStatus = SS_PENDING          ' Wait until command has completed.
  DoEvents                                    ' Yield to other processes while waiting.
  Sleep 50
Loop

' ****** Testing *******
'Debug.Print "CmdStatus=" + Str(SRB.SRBCmdStatus), "HaStat=" + Str(SRB.SRBHaStat), "TargetStat=" + Str(SRB.SRBTargetStat)
' ****** Testing *******

Select Case SRB.SRBCmdStatus                    ' Function/command return code is here.

    Case SS_COMP                                ' Command completed ok.
        
        ModeSelect = True
        
    Case SS_ERR                                 ' Command completed w/error.

        ModeSelect = False
        
    Case Else
    
        MsgBox ("Undefined error in ModeSelect procedure.")
        
End Select

End Function

Public Function ModeSense(AdapterNum As Byte, TargetId As Byte, ModeSenseData() As Byte) As Boolean

Dim AspiStatus As Long
Dim SRB As SRBExecIoCmdStruct
Dim i As Long

' Initialize required variables before calling function.
SRB.SRBCmd = SC_EXEC_SCSI_CMD
SRB.SRBHaId = AdapterNum
SRB.SRBFlags = SRB_DIR_IN                       ' Data coming from target.
SRB.SRBHdrRsvd = 0
SRB.SRBTarget = TargetId
SRB.SRBLun = LUN
SRB.SRBRsvd1 = 0
SRB.SRBBufLen = 12                              ' 12-bytes of Sense data will be returned.
SRB.SRBBufPointer = VarPtr(ModeSenseData(0))    ' Point to array to hold sense data.
SRB.SRBSenseLen = SENSE_LEN
SRB.SRBCDBLen = 6
SRB.SRBPostProc = vbNull                        ' With polling, no function or handle to point to.
SRB.SRBRsvd2 = 0
For i = 0 To 15                                 ' Fill this reserved field with all zeros.
    SRB.SRBRsvd3(i) = 0
Next i
SRB.CDBByte(0) = SCSI_MODE_SEN6                 ' 6-byte Mode sense command.
SRB.CDBByte(1) = 0
SRB.CDBByte(2) = 0
SRB.CDBByte(3) = 0
SRB.CDBByte(4) = 12                             ' Allocation Length. Return Parameter List
                                                ' Header (4-bytes) and Block Descriptor (8-bytes).
SRB.CDBByte(5) = 0

AspiStatus = ExecuteIoCommand(SRB)

Do While SRB.SRBCmdStatus = SS_PENDING          ' Wait until command has completed.
  DoEvents                                    ' Yield to other processes while waiting.
  Sleep 50
Loop

' ****** Testing *******
'Debug.Print "CmdStatus=" + Str(SRB.SRBCmdStatus), "HaStat=" + Str(SRB.SRBHaStat), "TargetStat=" + Str(SRB.SRBTargetStat)
' ****** Testing *******

Select Case SRB.SRBCmdStatus                    ' Function/command return code is here.

    Case SS_COMP                                ' Command completed ok.
        
    Case SS_ERR                                 ' Command completed w/error.

    Case Else
    
End Select

End Function
Public Function DecodeSubcodeData( _
  SubcodeData() As Byte, _
  DecodedSubcode As DecodedSubcodeStruct, _
  Optional DecodeTimeStuff As Boolean = False) As Long
  
  Dim SampleRateRead As Byte
  Dim j As Integer, numSubpacks As Integer
  ' sample rate
  SampleRateRead = SubcodeData(SUBCODE_SAMPLERATE_BYTE) And SUBCODE_SAMPLERATE_MASK
  
  If SampleRateRead = SUBCODE_SAMPLERATE_48 Then
    DecodedSubcode.SampleRate = SAMPLE_RATE_48
  ElseIf SampleRateRead = SUBCODE_SAMPLERATE_44 Then
    DecodedSubcode.SampleRate = SAMPLE_RATE_44
  ElseIf SampleRateRead = SUBCODE_SAMPLERATE_32 Then
    DecodedSubcode.SampleRate = SAMPLE_RATE_32
  Else
    DecodedSubcode.SampleRate = SAMPLE_RATE_UNK
  End If
  
  ' bad data flag
  If SubcodeData(SUBCODE_INTERPOLATEFLAGS_BYTE) <> 0 Then
    DecodedSubcode.ErrorFlag = True
  Else
    DecodedSubcode.ErrorFlag = False
  End If
    
  ' program id
  If SubcodeData(SUBCODE_PROGID_MID_BYTE) = &HAA Then
    DecodedSubcode.ProgramIDValid = False
    DecodedSubcode.ProgramID = 0
    DecodedSubcode.ProgramIdString = "---"
  ElseIf SubcodeData(SUBCODE_PROGID_MID_BYTE) = &HBB Then
    DecodedSubcode.ProgramIDValid = False
    DecodedSubcode.ProgramID = 0
    DecodedSubcode.ProgramIdString = " BB"
  ElseIf SubcodeData(SUBCODE_PROGID_MID_BYTE) = &HEE Then
    DecodedSubcode.ProgramIDValid = False
    DecodedSubcode.ProgramID = 0
    DecodedSubcode.ProgramIdString = " EE"
  Else
    DecodedSubcode.ProgramIDValid = True
    DecodedSubcode.ProgramID = 100 * (SubcodeData(SUBCODE_PROGID_HIGH_BYTE) \ 16) _
      + BcdToLong(SubcodeData(SUBCODE_PROGID_MID_BYTE))
'    DecodedSubcode.ProgramIDString = DecodedSubcode.ProgramID
    DecodedSubcode.ProgramIdString = SubcodeData(SUBCODE_PROGID_HIGH_BYTE) \ 16 _
       & SubcodeData(SUBCODE_PROGID_MID_BYTE) \ 16 _
       & SubcodeData(SUBCODE_PROGID_MID_BYTE) Mod 16
  End If

  If DecodeTimeStuff = True Then
    DecodedSubcode.PTimeHours = 0
    DecodedSubcode.PTimeMins = 0
    DecodedSubcode.PTimeSecs = 0
    DecodedSubcode.ATimeHours = 0
    DecodedSubcode.ATimeMins = 0
    DecodedSubcode.ATimeSecs = 0
        
    ' timestamps - stored in subpacks
    numSubpacks = SubcodeData(SUBCODE_SUBPACKCOUNT_BYTE) Mod 16
          
    For j = 0 To numSubpacks - 1 ' run through all the subcode packs
      If SubcodeData(j * 8) \ 16 = 1 Then
        ' program time - packed in bytes 3, 4, 5
        DecodedSubcode.PTimeHours = BcdToLong(SubcodeData(j * 8 + 3))
        DecodedSubcode.PTimeMins = BcdToLong(SubcodeData(j * 8 + 4))
        DecodedSubcode.PTimeSecs = BcdToLong(SubcodeData(j * 8 + 5))
        DecodedSubcode.PTimeFrame = BcdToLong(SubcodeData(j * 8 + 6))
      ElseIf SubcodeData(j * 8) \ 16 = 2 Then
        ' absolute time - packed in bytes 3, 4, 5
        DecodedSubcode.ATimeHours = BcdToLong(SubcodeData(j * 8 + 3))
        DecodedSubcode.ATimeMins = BcdToLong(SubcodeData(j * 8 + 4))
        DecodedSubcode.ATimeSecs = BcdToLong(SubcodeData(j * 8 + 5))
        DecodedSubcode.ATimeFrame = BcdToLong(SubcodeData(j * 8 + 6))
      End If
    Next j
  End If
End Function

Private Function SetupWavefileHeader(WavFileHeader As WavFileHeaderStruct, SampleRate As Long)

  WavFileHeader.HeaderName = "RIFF"
  WavFileHeader.WavName = "WAVE"
  WavFileHeader.FmtName = "fmt "
  WavFileHeader.FmtChunkSize = 16
  WavFileHeader.DataType = 1
  WavFileHeader.NumChannels = 2
  If SampleRate = SAMPLE_RATE_48 Then
    WavFileHeader.SampleRate = 48000
  Else
    WavFileHeader.SampleRate = 44100
  End If
  WavFileHeader.AvBytesPerSec = WavFileHeader.SampleRate * 4
  
  WavFileHeader.BlockAlign = 4
  WavFileHeader.SampleSize = 16
  WavFileHeader.DataName = "data"
  
  'these need to be updated when file is closed
  ' I'm pretending it's some really big file so you can play it while you write it
  WavFileHeader.RiffChunkSize = 500000000 - 8
  WavFileHeader.DataLen = 500000000 - 44
'    Put FileNum, 5, FileLength - 8                  ' Write the RifChunkSize in the WAV header.
'    Put FileNum, 41, FileLength - 44                ' Write the DataLen in the WAV header.
    
  
End Function
Private Function SetFilename(filename As String) As Boolean
  On Error GoTo errhandler
  
  frmDeck.CommonDialog1.filename = filename
  frmDeck.CommonDialog1.Filter = "Wav files (*.wav)|*.wav|All Files (*.*)|*.*"
  frmDeck.CommonDialog1.FilterIndex = 1
  frmDeck.CommonDialog1.CancelError = True
  frmDeck.CommonDialog1.Flags = cdlOFNOverwritePrompt
  frmDeck.CommonDialog1.ShowSave
  
  filename = frmDeck.CommonDialog1.filename
    
  SetFilename = True
  Exit Function
  
errhandler:
  SetFilename = False
  
End Function
Public Function Play() As Boolean

  Dim Status As Long
  Dim ReadFrameStatus As Boolean
  Dim BoolStatus As Boolean
  
  Dim i As Long
  Dim DataErrorFlag As Byte
  Dim ErrorCount As Long, GlobalErrorCount As Long, QuitErrorCount As Long
  Dim bIgnoreErrors As Boolean
  
  Dim SubcodeInfo As DecodedSubcodeStruct
  Dim CurrentProgID As Byte

  Dim DatFrame48 As DatFrame48Struct
  Dim DatFrame44 As DatFrame44Struct

  Dim ReadFrameCount As Long, WriteFrameCount As Long
  
  Dim ErrorLog As String, Seconds As Double
  
'  Dim LastProgramID As Byte ' made this global so can do next and prev
  Dim LastProgramIDString As String
  Dim LastPTimeHours As Long
  Dim LastPTimeMins As Long
  Dim LastPTimeSecs As Long
  Dim LastATime As Long, NewATime As Long ' seconds
  Dim UserAnswer As Long
  LastProgramID = 255
  LastPTimeHours = 0
  LastPTimeMins = 0
  LastPTimeSecs = 0
  LastATime = 0
  
  If (Playing) Then
      Play = True
      Exit Function
  End If

  ' read first frame to determine proper sample rate, etc
  BoolStatus = False
  ErrorCount = 0
  GlobalErrorCount = 0
  QuitErrorCount = 30 ' 30 frames is one second
  ReadFrameCount = 0
  WriteFrameCount = 0
  bIgnoreErrors = False
    
  ErrLogFileNum = FreeFile
  Open DefaultErrLogFilename For Output Access Write As ErrLogFileNum   ' Reset file to zero byte length.
  Close ErrLogFileNum
  Open DefaultErrLogFilename For Append As ErrLogFileNum   ' Reset file to zero byte length.
    
  Do Until BoolStatus = True
    ' DatFrame48 is arbitrary here - copy data to DatFrame44 if actual sample
    ' rate is 44
    ReadFrameStatus = ReadFrame(CardID, TapeID, VarPtr(DatFrame48), FRAMESIZE)
    ReadFrameCount = ReadFrameCount + 1
    If ReadFrameStatus = True Then
      DecodeSubcodeData DatFrame48.SubcodeData, SubcodeInfo, True
      
      ' skip any leadin frames (we aren't necessarily at start of tape though)
      If SubcodeInfo.ErrorFlag = True Then
        ErrorCount = ErrorCount + 1
      ' decided this was a bad idea - marty G
      Else
'      ElseIf SubcodeInfo.ProgramIDValid = True And SubcodeInfo.ProgramIdString <> " BB" Then
        ' not sure if this is a good idea or not - seemed to fail with some tapes
'        If SubcodeInfo.ATimeHours <> 110 And SubcodeInfo.ATimeMins <> 110 And SubcodeInfo.ATimeSecs <> 110 And SubcodeInfo.ATimeFrame <> 110 Then
'          ' visual basic is too stupid to short cut this if they are all 110s - causes overflow
'          If SubcodeInfo.ATimeHours + SubcodeInfo.ATimeMins + SubcodeInfo.ATimeSecs + SubcodeInfo.ATimeFrame > 0 Then
            BoolStatus = True ' found a valid frame of data
'          End If
'        End If
      End If
    Else
      ErrorCount = ErrorCount + 1
    End If
    
    If BoolStatus = False And ErrorCount > QuitErrorCount Then
      ErrorLog = "can't read tape - maybe need rewind" & vbCrLf
Print #ErrLogFileNum, ErrorLog
      MsgBox "can't read tape - maybe need rewind"
      GoTo cleanup
    End If
  Loop
  
  If ErrorCount > 0 Then
    ErrorLog = "read " & ErrorCount & " bad frames at start of tape" & vbCrLf
Print #ErrLogFileNum, ErrorLog
  End If
  Close ErrLogFileNum
  
  SampleRate = SubcodeInfo.SampleRate
  If SampleRate = SAMPLE_RATE_44 Then
    CopyMemory VarPtr(DatFrame44), VarPtr(DatFrame48), Len(DatFrame48)
  End If
  
NewSampleRate: ' can come here from below if detect sample rate change
  If SampleRate = SAMPLE_RATE_48 Or SampleRate = SAMPLE_RATE_44 Then
    frmDeck.SetSampleRateLabel SampleRate
  ElseIf SampleRate = SAMPLE_RATE_32 Then
    MsgBox "unsupported sample rate: 32k"
    Play = False
    Exit Function
  Else
    MsgBox "Can't decode sample rate"
    Play = False
    Exit Function
  End If

  BoolStatus = SetFilename(BaseFileName)
  If BoolStatus = False Then
    Play = False
    Exit Function
  End If
  
newFile: ' can come here from below if prog id changes and splitting file
  CurrentProgID = SubcodeInfo.ProgramID
  WavFileName = BaseFileName
  
  FileNum = FreeFile                              ' Get the next available file number.
  Open WavFileName For Output Access Write As FileNum   ' Reset file to zero byte length.
  Close FileNum
  ReadFrameCount = 0  ' want it to correspond to frames written
  
  ErrLogFileNum = FreeFile                              ' Get the next available file number.
  Open DefaultErrLogFilename For Append As ErrLogFileNum
  
  ' wav file header setup
  ' will need to go back and write file size when closing file
  Dim WavFileHeader As WavFileHeaderStruct
  SetupWavefileHeader WavFileHeader, SampleRate
  
  FileNum = FreeFile                              ' Get the next available file number.
  Open WavFileName For Binary As FileNum       ' Store the WAV header and audio data here.
  Put FileNum, , WavFileHeader                   ' Write the WAV header to the file.
  '--------------------------------------
  
  Playing = True
  Play = True

  Dim j As Byte
  Dim retryCount As Long
  
  retryCount = 0
    
  Dim numSubpacks As Byte
                
  ErrorCount = 0
  
  Do Until Playing = False
            
    
    ' marty experiment - appears to not work
'    If (ReadFrameStatus <> True Or SubcodeInfo.ErrorFlag = True) And retryCount = 0 Then
'        If SampleRate = SAMPLE_RATE_48 Then
'          ReadFrameStatus = ReadFrameReverse(CardID, TapeID, VarPtr(DatFrame48), FRAMESIZE)
'          DecodeSubcodeData DatFrame48.SubcodeData, SubcodeInfo
'        Else
'          ReadFrameStatus = ReadFrameReverse(CardID, TapeID, VarPtr(DatFrame44), FRAMESIZE)
'          DecodeSubcodeData DatFrame44.SubcodeData, SubcodeInfo
'        End If
'        retryCount = 1
'    End If
    
    ' ? do we have to do a forward read again
    
    If ReadFrameStatus <> True Then
      ErrorCount = ErrorCount + 1
      GlobalErrorCount = GlobalErrorCount + 1
      If ErrorCount > QuitErrorCount Then
        ErrorLog = GlobalErrorCount & ": Got " & QuitErrorCount & " consecutive bad frames - tape finished or unreadable, quitting; read " & ReadFrameCount & " frames, skipped error frames = " & ReadFrameCount - WriteFrameCount & vbCrLf
Print #ErrLogFileNum, ErrorLog

        MsgBox "Got " & QuitErrorCount & " consecutive bad frames - tape finished or unreadable, quitting; read " & ReadFrameCount & " frames, skipped error frames = " & ReadFrameCount - WriteFrameCount
        GoTo cleanup
      Else
        Seconds = Frames2Seconds(WriteFrameCount)
        ErrorLog = vbCrLf & "Error on read frame - frame skipped = :" & bIgnoreErrors & vbCrLf & _
          " - last valid atime was " & LastATime \ 3600 & ":" & (LastATime Mod 3600) \ 60 & ":" & LastATime Mod 3600 & vbCrLf & _
          " - frame number is " & WriteFrameCount & ", time in .wav approx " & _
              Seconds \ 3600 & ":" & (Seconds Mod 3600) \ 60 & ":" & _
              Seconds - 60 * (Seconds \ 60)
        
Print #ErrLogFileNum, ErrorLog
' marty experiment, assume 44k for this
'For i = 0 To AUDIOSIZE44 - 1
'DatFrame44.AudioData(i) = 0
'Next


'        If bIgnoreErrors = False Then GoTo nextFrame
      End If
    End If
            
    ' try to detect end of recorded section (but none of my tapes have this program ID!)
    If SubcodeInfo.ProgramIdString = " EE" Then
        MsgBox "reached end of tape - quitting; read " & ReadFrameCount & " frames, total error frames = " & ReadFrameCount - WriteFrameCount
        GoTo cleanup
    End If
    
    ' ReadFrameStatus will catch end of tape but not end of recording
    ' I saw that the data error flag gets set for the final frames -
    ' not sure if I should abort on that or not
    If ReadFrameStatus = True And SubcodeInfo.ErrorFlag <> False And SubcodeInfo.ProgramIdString <> " BB" Then
      ErrorCount = ErrorCount + 1
      GlobalErrorCount = GlobalErrorCount + 1
      If ErrorCount > QuitErrorCount Then
        MsgBox "Got " & QuitErrorCount & " consecutive bad frames - tape finished or unreadable, quitting; read " & ReadFrameCount & " frames, skipped error frames = " & ReadFrameCount - WriteFrameCount
        GoTo cleanup
'      Else
'        ErrorLog = vbCrLf & GlobalErrorCount & ": Frame read OK but data flag bad, last valid atime was " _
'          & (LastATime \ 3600) & ":" & ((LastATime Mod 3600) \ 60) & ":" & (LastATime Mod 3600)
'Print #ErrLogFileNum, ErrorLog
''        If bIgnoreErrors = False Then GoTo nextFrame
      End If
    End If
    
    If ErrorCount > 0 Then
'      If bIgnoreErrors = False Then
'        UserAnswer = MsgBox("Got " & ErrorCount & " consecutive bad frames - ignore errors? Yes to ignore all, No to continue, Cancel to quit", vbYesNoCancel)
'        If UserAnswer = vbCancel Then
'          GoTo cleanup
'        ElseIf UserAnswer = vbYes Then
'          bIgnoreErrors = True
'        Else
'          bIgnoreErrors = False
'        End If
'      End If
      
      Seconds = Frames2Seconds(WriteFrameCount)
      ErrorLog = GlobalErrorCount & ": Got " & ErrorCount & " consecutive bad frames " & vbCrLf & _
          " - last valid atime was " & LastATime \ 3600 & ":" & (LastATime Mod 3600) \ 60 & ":" & LastATime Mod 60 & vbCrLf & _
          " - frame number is " & WriteFrameCount & ", time in .wav approx " & _
              Seconds \ 3600 & ":" & (Seconds Mod 3600) \ 60 & ":" & _
              Seconds - 60 * (Seconds \ 60)
Print #ErrLogFileNum, ErrorLog
' marty experiment, assume 44k for this
'For i = 0 To AUDIOSIZE44 - 1
'DatFrame44.AudioData(i) = 0
'Next
    
    End If
            
    If ReadFrameStatus = True And SubcodeInfo.ErrorFlag = False Then ErrorCount = 0
    
    ' watch for sample rate change
    If SubcodeInfo.SampleRate <> SampleRate Then
      If SubcodeInfo.SampleRate = SAMPLE_RATE_32 Or SubcodeInfo.SampleRate = SAMPLE_RATE_UNK Then
        If MsgBox("Got unsupported sample rate " & SubcodeInfo.SampleRate & " frame - hit OK to skip, cancel to quit", vbOKCancel) = vbOK Then
          GoTo nextFrame
        Else
          GoTo cleanup
        End If
      End If
      
      If MsgBox("got sample rate change from " & SampleRate & " to " & SubcodeInfo.SampleRate & " - continue with new file?", vbOKCancel) = vbOK Then
        StopPlay
        ' move data to proper struct and try again
        ' this would really be easier in c++
        If SampleRate = SAMPLE_RATE_44 Then
          CopyMemory VarPtr(DatFrame44), VarPtr(DatFrame48), Len(DatFrame48)
        Else
          CopyMemory VarPtr(DatFrame48), VarPtr(DatFrame44), Len(DatFrame44)
        End If
        SampleRate = SubcodeInfo.SampleRate
        GoTo NewSampleRate
      Else
        GoTo cleanup
      End If
    End If
            
    If Playing = True Then ' watch for them hitting stop play on us
      If SampleRate = SAMPLE_RATE_48 Then
        Put FileNum, , DatFrame48.AudioData
      Else
        Put FileNum, , DatFrame44.AudioData
      End If
      WriteFrameCount = WriteFrameCount + 1
    Else
      GoTo cleanup
    End If
          
    ' update time display once a second or so
    If ReadFrameCount > 0 And ReadFrameCount Mod 33 = 0 Then
      ' decode subcode again with time info (decode defaults to ignoring time)
      If SampleRate = SAMPLE_RATE_48 Then
        DecodeSubcodeData DatFrame48.SubcodeData, SubcodeInfo, True
      Else
        DecodeSubcodeData DatFrame44.SubcodeData, SubcodeInfo, True
      End If
      
      ' set absolute time - should always be valid but some LFC recordings weren't
       If SubcodeInfo.ATimeHours <> 110 And SubcodeInfo.ATimeMins <> 110 And SubcodeInfo.ATimeSecs <> 110 And SubcodeInfo.ATimeFrame <> 110 Then
         ' visual basic is too stupid to short cut this if they are all 110s - causes overflow
         If SubcodeInfo.ATimeHours + SubcodeInfo.ATimeMins + SubcodeInfo.ATimeSecs + SubcodeInfo.ATimeFrame > 0 Then
           frmDeck.SetAtime SubcodeInfo.ATimeHours, SubcodeInfo.ATimeMins, SubcodeInfo.ATimeSecs
           NewATime = SubcodeInfo.ATimeHours * 3600 + SubcodeInfo.ATimeMins * 60 + SubcodeInfo.ATimeSecs
           If LastATime = 0 Then LastATime = NewATime
         End If
      End If
      
      ' program time is only valid if at start of a program else have to keep track ourselves
      If SubcodeInfo.ProgramIDValid = True Then
        LastProgramID = SubcodeInfo.ProgramID
        LastProgramIDString = SubcodeInfo.ProgramIdString
        LastPTimeHours = SubcodeInfo.PTimeHours
        LastPTimeMins = SubcodeInfo.PTimeMins
        LastPTimeSecs = SubcodeInfo.PTimeSecs
      Else
        LastPTimeSecs = LastPTimeSecs + NewATime - LastATime
        ' saw this happen
        If LastPTimeSecs < 0 Then LastPTimeSecs = 0
        
        LastPTimeMins = LastPTimeMins + LastPTimeSecs \ 60
        LastPTimeSecs = LastPTimeSecs Mod 60
        
        LastPTimeHours = LastPTimeHours + LastPTimeMins \ 60
        LastPTimeMins = LastPTimeMins Mod 60
      End If
      
      LastATime = NewATime
      SubcodeInfo.ProgramID = LastProgramID
      SubcodeInfo.ProgramIdString = LastProgramIDString
      SubcodeInfo.PTimeHours = LastPTimeHours
      SubcodeInfo.PTimeMins = LastPTimeMins
      SubcodeInfo.PTimeSecs = LastPTimeSecs
      
      frmDeck.SetPTime SubcodeInfo.PTimeHours, SubcodeInfo.PTimeMins, SubcodeInfo.PTimeSecs, SubcodeInfo.ProgramIdString
    End If
            
nextFrame:
    SampleRate = SubcodeInfo.SampleRate
    ReadFrameCount = ReadFrameCount + 1
    If SampleRate = SAMPLE_RATE_48 Then
      ReadFrameStatus = ReadFrame(CardID, TapeID, VarPtr(DatFrame48), FRAMESIZE)
      DecodeSubcodeData DatFrame48.SubcodeData, SubcodeInfo
    Else
      ReadFrameStatus = ReadFrame(CardID, TapeID, VarPtr(DatFrame44), FRAMESIZE)
      DecodeSubcodeData DatFrame44.SubcodeData, SubcodeInfo
    End If
    retryCount = 0
  Loop
  
cleanup:
  If ErrorLog <> "" And GlobalErrorCount > 0 And GlobalErrorCount <> ErrorCount Then
    MsgBox GlobalErrorCount - ErrorCount & " errors were logged - see " & DefaultErrLogFilename, vbOK
  End If
    
  StopPlay

End Function

Public Function PreventRemoval(AdapterNum As Byte, TargetId As Byte, PREVENT As Byte) As Boolean

Dim AspiStatus As Long
Dim SRB As SRBExecIoCmdStruct
Dim i As Long

' Initialize required variables before calling function.
SRB.SRBCmd = SC_EXEC_SCSI_CMD
SRB.SRBHaId = AdapterNum
SRB.SRBFlags = 0                                ' Set polling mode.
SRB.SRBHdrRsvd = 0
SRB.SRBTarget = TargetId
SRB.SRBLun = LUN
SRB.SRBRsvd1 = 0
SRB.SRBBufLen = 0                               ' No data transfered with this command,
SRB.SRBBufPointer = vbNull                      ' so no data buffer needed.
SRB.SRBSenseLen = SENSE_LEN
SRB.SRBCDBLen = 6
SRB.SRBPostProc = vbNull                        ' Use polling to determine command completion.
SRB.SRBRsvd2 = 0
For i = 0 To 15                                 ' Fill this reserved field with all zeros.
    SRB.SRBRsvd3(i) = 0
Next i
SRB.CDBByte(0) = SCSI_PREVENT_ALLOW             ' Prevent/Allow Medium Removal command.
SRB.CDBByte(1) = 0
SRB.CDBByte(2) = 0
SRB.CDBByte(3) = 0
SRB.CDBByte(4) = 0
SRB.CDBByte(5) = PREVENT                        ' Low bit determines prevent/allow.

AspiStatus = ExecuteIoCommand(SRB)

Do While SRB.SRBCmdStatus = SS_PENDING          ' Wait until command has completed.
  DoEvents                                    ' Yield to other processes while waiting.
  Sleep 50
Loop

'****** Testing ******
'Debug.Print "CmdStatus=" + Str(SRB.SRBCmdStatus), "HaStat=" + Str(SRB.SRBHaStat), "TargetStat=" + Str(SRB.SRBTargetStat)
'Debug.Print "Sense Key=" + Hex(SRB.SenseArea(2)) + "H", "ASC=" + Hex(SRB.SenseArea(12))
'****** Testing ******

Select Case SRB.SRBCmdStatus                    ' Function/command return code is here.

    Case SS_COMP
        PreventRemoval = True                   ' Command succeeded.
        
    Case Else
        PreventRemoval = False                  ' Command did not succeed.
        
End Select

End Function

Public Function ReadFrameReverse( _
AdapterNum As Byte, _
TargetId As Byte, _
FrameData As Long, _
BlockLen As Long) As Boolean

' This doesn't appear to work. No Read Reverse function on drive?

Dim AspiStatus As Long
Dim SRB As SRBExecIoCmdStruct
Dim i As Long
Dim MSB As Byte                                 ' MSB of data transfer length.
Dim NSB As Byte                                 ' Middle byte of data transfer length.
Dim LSB As Byte                                 ' LSB of data transfer length.

MSB = BlockLen \ 65536
NSB = (BlockLen Mod 65536) \ 256
LSB = BlockLen - (CLng(MSB) * 65536) - (CLng(NSB) * 256)

' Initialize required variables before calling function.
SRB.SRBCmd = SC_EXEC_SCSI_CMD
SRB.SRBHaId = AdapterNum
SRB.SRBFlags = SRB_DIR_IN                       ' Data coming from target.
SRB.SRBHdrRsvd = 0
SRB.SRBTarget = TargetId
SRB.SRBLun = LUN
SRB.SRBRsvd1 = 0
SRB.SRBBufLen = BlockLen                        ' Number of bytes to read.
SRB.SRBBufPointer = FrameData                   ' Point to structure to hold data read.
SRB.SRBSenseLen = SENSE_LEN
SRB.SRBCDBLen = 6
SRB.SRBPostProc = vbNull                        ' With polling, no function or handle to point to.
SRB.SRBRsvd2 = 0
For i = 0 To 15                                 ' Fill this reserved field with all zeros.
    SRB.SRBRsvd3(i) = 0
Next i
SRB.CDBByte(0) = SCSI_READ_REV                  ' Read Reverse command.
SRB.CDBByte(1) = 0
SRB.CDBByte(2) = MSB                            ' MSB.
SRB.CDBByte(3) = NSB                            ' Data transfer length.
SRB.CDBByte(4) = LSB                            ' LSB.
SRB.CDBByte(5) = 0

AspiStatus = ExecuteIoCommand(SRB)

Do While SRB.SRBCmdStatus = SS_PENDING          ' Wait until command has completed.
  DoEvents                                    ' Yield to other processes while waiting.
  Sleep 5
Loop

' ****** Testing *******
'Debug.Print "CmdStatus=" + Str(SRB.SRBCmdStatus), "HaStat=" + Str(SRB.SRBHaStat), "TargetStat=" + Str(SRB.SRBTargetStat)
' ****** Testing *******

Select Case SRB.SRBCmdStatus                    ' Function/command return code is here.

    Case SS_COMP                                ' Command completed ok.
    ReadFrameReverse = True
        
    Case SS_ERR                                 ' Command completed w/error.
    ReadFrameReverse = False

    Case Else
    ReadFrameReverse = False
    
End Select

End Function

' lame marty version couldn't figure out how to overlay structs easily
Public Function ReadFrame( _
 AdapterNum As Byte, _
 TargetId As Byte, _
 FrameData As Long, _
 BlockLen As Long) As Boolean

Dim AspiStatus As Long
Dim SRB As SRBExecIoCmdStruct
Dim i As Long
Dim MSB As Byte                                 ' MSB of data transfer length.
Dim NSB As Byte                                 ' Middle byte of data transfer length.
Dim LSB As Byte                                 ' LSB of data transfer length.

MSB = BlockLen \ 65536
NSB = (BlockLen Mod 65536) \ 256
LSB = BlockLen - (CLng(MSB) * 65536) - (CLng(NSB) * 256)

' Initialize required variables before calling function.
SRB.SRBCmd = SC_EXEC_SCSI_CMD
SRB.SRBHaId = AdapterNum
SRB.SRBFlags = SRB_DIR_IN                       ' Data coming from target.
SRB.SRBHdrRsvd = 0
SRB.SRBTarget = TargetId
SRB.SRBLun = LUN
SRB.SRBRsvd1 = 0
SRB.SRBBufLen = BlockLen                        ' Number of bytes to read.
SRB.SRBBufPointer = FrameData           ' Point to structure to hold data read.
SRB.SRBSenseLen = SENSE_LEN
SRB.SRBCDBLen = 6
SRB.SRBPostProc = vbNull                        ' With polling, no function or handle to point to.
SRB.SRBRsvd2 = 0
For i = 0 To 15                                 ' Fill this reserved field with all zeros.
    SRB.SRBRsvd3(i) = 0
Next i
SRB.CDBByte(0) = SCSI_READ                      ' Read command.
SRB.CDBByte(1) = 0
SRB.CDBByte(2) = MSB                            ' MSB.
SRB.CDBByte(3) = NSB                            ' Data transfer length.
SRB.CDBByte(4) = LSB                            ' LSB.
SRB.CDBByte(5) = 0

AspiStatus = ExecuteIoCommand(SRB)

Do While SRB.SRBCmdStatus = SS_PENDING          ' Wait until command has completed.
  DoEvents                                    ' Yield to other processes while waiting.
  Sleep 5
Loop

' ****** Testing *******
'Debug.Print "CmdStatus=" + Str(SRB.SRBCmdStatus), "HaStat=" + Str(SRB.SRBHaStat), "TargetStat=" + Str(SRB.SRBTargetStat)
' ****** Testing *******

' Q: what happens at last audio frame?
Select Case SRB.SRBCmdStatus                    ' Function/command return code is here.

    Case SS_COMP                                ' Command completed ok.
    ReadFrame = True
        
    Case SS_ERR                                 ' Command completed w/error.
    ReadFrame = False

    Case Else
    ReadFrame = False
    
End Select

End Function

Public Function ReadBlockLimits(AdapterNum As Byte, TargetId As Byte) As Boolean

Dim AspiStatus As Long
Dim SRB As SRBExecIoCmdStruct
Dim BlockLimitsData(5) As Byte
Dim MinBlockSize As Long
Dim MaxBlockSize As Long
Dim i As Long

' Initialize required variables before calling function.
SRB.SRBCmd = SC_EXEC_SCSI_CMD
SRB.SRBHaId = AdapterNum
SRB.SRBFlags = SRB_DIR_IN                       ' Data coming from target.
SRB.SRBHdrRsvd = 0
SRB.SRBTarget = TargetId
SRB.SRBLun = LUN
SRB.SRBRsvd1 = 0
SRB.SRBBufLen = 6                               ' 6-bytes of data will be returned.
SRB.SRBBufPointer = VarPtr(BlockLimitsData(0))  ' Point to array to hold data.
SRB.SRBSenseLen = SENSE_LEN
SRB.SRBCDBLen = 6
SRB.SRBPostProc = vbNull                        ' With polling, no function or handle to point to.
SRB.SRBRsvd2 = 0
For i = 0 To 15                                 ' Fill this reserved field with all zeros.
    SRB.SRBRsvd3(i) = 0
Next i
SRB.CDBByte(0) = SCSI_RD_BLK_LIM                ' Read Block Limits command.
SRB.CDBByte(1) = 0
SRB.CDBByte(2) = 0
SRB.CDBByte(3) = 0
SRB.CDBByte(4) = 0
SRB.CDBByte(5) = 0

AspiStatus = ExecuteIoCommand(SRB)

Do While SRB.SRBCmdStatus = SS_PENDING          ' Wait until command has completed.
  DoEvents                                    ' Yield to other processes while waiting.
  Sleep 50
Loop

MinBlockSize = BlockLimitsData(4) * 16 + BlockLimitsData(5)
MaxBlockSize = (CLng(BlockLimitsData(1)) * 65536) + (CLng(BlockLimitsData(2)) * 256) + CLng(BlockLimitsData(3))

Select Case SRB.SRBCmdStatus                    ' Function/command return code is here.

    Case SS_COMP                                ' Command completed ok.
        
    Case SS_ERR                                 ' Command completed w/error.

    Case Else
    
End Select

End Function


Public Function ReadPosition(AdapterNum As Byte, TargetId As Byte, ReadPositionData() As Byte) As Boolean

Dim AspiStatus As Long
Dim SRB As SRBExecIoCmdStruct
Dim i As Long

' Initialize required variables before calling function.
SRB.SRBCmd = SC_EXEC_SCSI_CMD
SRB.SRBHaId = AdapterNum
SRB.SRBFlags = SRB_DIR_IN                       ' Data coming from target.
SRB.SRBHdrRsvd = 0
SRB.SRBTarget = TargetId
SRB.SRBLun = LUN
SRB.SRBRsvd1 = 0
SRB.SRBBufLen = 20                              ' 20-bytes of position data will be returned.
SRB.SRBBufPointer = VarPtr(ReadPositionData(0)) ' Point to array to hold position data.
SRB.SRBSenseLen = SENSE_LEN
SRB.SRBCDBLen = 10
SRB.SRBPostProc = vbNull                        ' With polling, no function or handle to point to.
SRB.SRBRsvd2 = 0
For i = 0 To 15                                 ' Fill this reserved field with all zeros.
    SRB.SRBRsvd3(i) = 0
Next i
SRB.CDBByte(0) = SCSI_READ_POS                  ' Read Position command.
SRB.CDBByte(1) = 1
SRB.CDBByte(2) = 0
SRB.CDBByte(3) = 0
SRB.CDBByte(4) = 0
SRB.CDBByte(5) = 0
SRB.CDBByte(6) = 0
SRB.CDBByte(7) = 0
SRB.CDBByte(8) = 0
SRB.CDBByte(9) = 0

AspiStatus = ExecuteIoCommand(SRB)

Do While SRB.SRBCmdStatus = SS_PENDING          ' Wait until command has completed.
  DoEvents                                    ' Yield to other processes while waiting.
  Sleep 5
Loop

' ****** Testing *******
'Debug.Print "CmdStatus=" + Str(SRB.SRBCmdStatus), "HaStat=" + Str(SRB.SRBHaStat), "TargetStat=" + Str(SRB.SRBTargetStat)
' ****** Testing *******

Select Case SRB.SRBCmdStatus                    ' Function/command return code is here.

    Case SS_COMP                                ' Command completed ok.
      ReadPosition = True
        
    Case SS_ERR                                 ' Command completed w/error.
      ReadPosition = False

    Case Else
      ReadPosition = False
    
End Select

End Function

Public Function ResetSCSIDevice(AdapterNum As Byte, TargetId As Byte) As Boolean
        
' Reset Device is not supported by WinASPI. Function returns ok, but does nothing.
        
Dim AspiStatus As Long
Dim SRB As SRBResetDeviceStruct
Dim i As Long
        
SRB.SRBCmd = SC_RESET_DEV
SRB.SRBHaId = AdapterNum
SRB.SRBFlags = 0                                ' No data transfered.
SRB.SRBHdrRsvd = 0
SRB.SRBTarget = TargetId
SRB.SRBLun = LUN
For i = 0 To 11                                 ' Fill this reserved field with all zeros.
    SRB.SRBRsvd1(i) = 0
Next i
SRB.SRBPostProc = vbNull
SRB.SRBRsvd2 = 0
For i = 0 To 31                                 ' Fill this reserved field with all zeros.
    SRB.SRBRsvd3(i) = 0
Next i

AspiStatus = ResetDevice(SRB)

Do While SRB.SRBCmdStatus = SS_PENDING          ' Wait until command has completed.
  DoEvents                                    ' Yield to other processes while waiting.
  Sleep 50

Loop

' ****** Testing *******
'Debug.Print "CmdStatus=" + Str(SRB.SRBCmdStatus), "HaStat=" + Str(SRB.SRBHaStat), "TargetStat=" + Str(SRB.SRBTargetStat)
' ****** Testing *******

Select Case SRB.SRBCmdStatus                    ' Check return code.

    Case SS_COMP
'        MsgBox ("Device reset ok.")
        
    Case SS_ERR
'        MsgBox ("Device reset error.")

    Case Else
'        MsgBox ("Device reset did something else.")
        
End Select

End Function

Public Function Rewind(AdapterNum As Byte, TargetId As Byte) As Boolean

Dim AspiStatus As Long
Dim SRB As SRBExecIoCmdStruct
Dim i As Long

' Initialize required variables before calling function.
SRB.SRBCmd = SC_EXEC_SCSI_CMD
SRB.SRBHaId = AdapterNum
SRB.SRBFlags = 0                                ' Set polling mode.
SRB.SRBHdrRsvd = 0
SRB.SRBTarget = TargetId
SRB.SRBLun = LUN
SRB.SRBRsvd1 = 0
SRB.SRBBufLen = 0                               ' No data transfered with this command,
SRB.SRBBufPointer = vbNull                      ' so no data buffer needed.
SRB.SRBSenseLen = SENSE_LEN
SRB.SRBCDBLen = 6
SRB.SRBPostProc = vbNull                        ' With polling, no function or handle to point to.
SRB.SRBRsvd2 = 0
For i = 0 To 15                                 ' Fill this reserved field with all zeros.
    SRB.SRBRsvd3(i) = 0
Next i
SRB.CDBByte(0) = SCSI_REWIND                    ' Rewind command.
SRB.CDBByte(1) = 0
SRB.CDBByte(2) = 0
SRB.CDBByte(3) = 0
SRB.CDBByte(4) = 0
SRB.CDBByte(5) = 0

AspiStatus = ExecuteIoCommand(SRB)

Do While SRB.SRBCmdStatus = SS_PENDING          ' Wait until command has completed.
  DoEvents                                    ' Yield to other processes while waiting.
  Sleep 50
Loop

Select Case SRB.SRBCmdStatus                    ' Function/command return code is here.

    Case SS_COMP                                ' Command completed ok.
        
    Case SS_ERR                                 ' Command completed w/error.

    Case Else
    
End Select

End Function

Public Function SetAudioMode(AdapterNum As Byte, TargetId As Byte) As Boolean

Dim ModeData(11) As Byte
Dim Status As Boolean

ModeData(0) = 0                                 ' Reserved.
ModeData(1) = 0                                 ' Reserved.
ModeData(2) = &H10                              ' Set buffered mode (default).
ModeData(3) = 8                                 ' Block Descriptor Length (default).
ModeData(4) = AUDIO_MODE                        ' Audio mode density code.
ModeData(5) = 0                                 ' MSB.
ModeData(6) = 0                                 ' Number of blocks on tape (000H = default).
ModeData(7) = 0                                 ' LSB.
ModeData(8) = 0                                 ' Reserved.
ModeData(9) = 0                                 ' MSB.
ModeData(10) = 2                                ' Set 512 byte block size (020H = default).
ModeData(11) = 0                                ' LSB.

Status = ModeSelect(AdapterNum, TargetId, ModeData())

SetAudioMode = Status

End Function

Public Function SetNewMode(AdapterNum As Byte, TargetId As Byte, Mode As Byte) As Boolean

Dim ModeData(11) As Byte
Dim Status As Boolean

ModeData(0) = 0                                 ' Reserved.
ModeData(1) = 0                                 ' Reserved.
ModeData(2) = &H10                              ' Set buffered mode (default).
ModeData(3) = 8                                 ' Block Descriptor Length (default).
ModeData(4) = Mode                              ' Set density code.
ModeData(5) = 0                                 ' MSB.
ModeData(6) = 0                                 ' Number of blocks on tape (000H = default).
ModeData(7) = 0                                 ' LSB.
ModeData(8) = 0                                 ' Reserved.
ModeData(9) = 0                                 ' MSB.
ModeData(10) = 2                                ' Set 512 byte block size (020H = default).
ModeData(11) = 0                                ' LSB.

Status = ModeSelect(AdapterNum, TargetId, ModeData())

SetNewMode = Status

End Function

' convert frame count to seconds
Public Function Frames2Seconds(Frames As Long) As Double
    ' 33.3333 frames to a second, so 100 frames in 3 seconds
    Frames2Seconds = Frames * 0.03
End Function

Public Sub StopPlay()

Dim FileLength As Long

Playing = False

'LocateAbort = True

'If hWaveOut > 0 Then
'    waveOutReset hWaveOut
'End If

' Testing stuff to write a wave file.
'------------------------------------
If FileNum > 0 Then

    FileLength = LOF(FileNum)                       ' Get length of WAV file.
    
    Put FileNum, 5, FileLength - 8                  ' Write the RifChunkSize in the WAV header.
    Put FileNum, 41, FileLength - 44                ' Write the DataLen in the WAV header.
    
    Close FileNum                                   ' Close WAV file.
    FileNum = 0 ' marty
  
    Close ErrLogFileNum
    ErrLogFileNum = 0

End If
'------------------------------------

End Sub

Public Function TestUnitReady(AdapterNum As Byte, TargetId As Byte) As Long

Dim AspiStatus As Long
Dim SRB As SRBExecIoCmdStruct
Dim i As Long

' Initialize required variables before calling function.
SRB.SRBCmd = SC_EXEC_SCSI_CMD
SRB.SRBHaId = AdapterNum
SRB.SRBFlags = 0                                ' Set polling mode.
SRB.SRBHdrRsvd = 0
SRB.SRBTarget = TargetId
SRB.SRBLun = LUN
SRB.SRBRsvd1 = 0
SRB.SRBBufLen = 0                               ' No data transfered with this command,
SRB.SRBBufPointer = vbNull                      ' so no data buffer needed.
SRB.SRBSenseLen = SENSE_LEN
SRB.SRBCDBLen = 6
SRB.SRBPostProc = vbNull                        ' Use polling to determine command completion.
SRB.SRBRsvd2 = 0
For i = 0 To 15                                 ' Fill this reserved field with all zeros.
    SRB.SRBRsvd3(i) = 0
Next i
SRB.CDBByte(0) = SCSI_TST_U_RDY                 ' Test Unit Ready command.
SRB.CDBByte(1) = 0
SRB.CDBByte(2) = 0
SRB.CDBByte(3) = 0
SRB.CDBByte(4) = 0
SRB.CDBByte(5) = 0

AspiStatus = ExecuteIoCommand(SRB)

Do While SRB.SRBCmdStatus = SS_PENDING          ' Wait until command has completed.
  DoEvents                                    ' Yield to other processes while waiting.
  Sleep 50
Loop

'****** Testing ******
'Debug.Print "CmdStatus=" + Str(SRB.SRBCmdStatus), "HaStat=" + Str(SRB.SRBHaStat), "TargetStat=" + Str(SRB.SRBTargetStat)
'Debug.Print "Sense Key=" + Hex(SRB.SenseArea(2)) + "H", "ASC=" + Hex(SRB.SenseArea(12))
'****** Testing ******

Select Case SRB.SRBCmdStatus                    ' Function/command return code is here.

    Case SS_COMP
        TestUnitReady = READY                   ' Target device is ready.
        
    Case SS_ERR
        Select Case SRB.SenseArea(2)            ' Look at Sense Key.
        
            Case KEY_NOTREADY                   ' Not Ready.
                Select Case SRB.SenseArea(12)   ' Look at ASC.
                
                    Case 4
                        If SRB.SenseArea(13) = 1 Then
                            TestUnitReady = BUSY        ' Unit is becoming ready.
                        Else
                            TestUnitReady = UNDEFINED   ' Some other problem.
'                            MsgBox ("Error in TestUnitReady function: Unit not ready ASCQ.")
                        End If
                        
                    Case &H3A                   ' No tape in drive or tape ejected by program.
                        TestUnitReady = TAPE_NONE
                    
                    Case &H5A                   ' User pressed eject button.
                        TestUnitReady = TAPE_NONE
                        
                        
                    Case Else
                        TestUnitReady = UNDEFINED       ' Some other problem.
                        MsgBox ("Error in TestUnitReady function: Unit not ready ASC.")
                        
                End Select
                
            Case KEY_HARDERROR ' I saw this with no tape in when asking again after
                               ' receiving a KEY_NOTREADY
                TestUnitReady = TAPE_NONE
                               
            
            Case KEY_UNITATT                    ' Unit Attention.
                Select Case SRB.SenseArea(12)   ' Look at ASC.
                
                    Case &H28                   ' New tape was loaded.
                        TestUnitReady = TAPE_NEW
                        
                    Case &H29                   ' Reset was reported.
                        TestUnitReady = RESET
                        
                    Case Else
                        TestUnitReady = UNDEFINED       ' Some other problem.
                        MsgBox ("Error in TestUnitReady function: Unit Attention ASC=" + Str(SRB.SenseArea(12)) + ".")
                    
                End Select
            
        
            Case Else
                TestUnitReady = UNDEFINED       ' Some other problem.
                MsgBox ("Error in TestUnitReady function: Sense Key=" + Str(SRB.SenseArea(2)) + ".")
                
        End Select
            
    Case Else
        TestUnitReady = UNDEFINED               ' Unknown/undefined status.
        MsgBox ("Error in TestUnitReady function: SRB Command status=" + Str(SRB.SRBCmdStatus) + ".")
        
End Select

End Function



Public Sub Initialize(hWndIn As Long)

hWnd = hWndIn

Playing = False

End Sub

' not used
Public Function WindowProc(ByVal hW As Long, ByVal uMsg As Long, ByVal wParam As Long, ByRef wavHdr As WaveHdrStruct) As Long

'On Error Resume Next
'
'Dim AudioBuffer() As Byte
'
'Dim AudioBufferPointer As Long
'Dim Status As Long
'Dim i As Long
'Static j As Long
'
'Exit Function
'

End Function


